package org.dimdev.dimdoors.api.block.entity;

import com.mojang.datafixers.types.Type;
import net.fabricmc.fabric.mixin.lookup.BlockEntityTypeAccessor;
import net.minecraft.class_2248;
import net.minecraft.class_2586;
import net.minecraft.class_2591;
import java.util.Arrays;
import java.util.HashSet;
import java.util.Set;

public class MutableBlockEntityType<T extends class_2586> extends class_2591<T> {

	public MutableBlockEntityType(BlockEntityFactory<? extends T> factory, Set<class_2248> blocks, Type<?> type) {
		// ensure that the Set is mutable
		super(factory, new HashSet<>(blocks), type);
	}

	public boolean addBlock(class_2248 block) {
		return ((BlockEntityTypeAccessor) this).getBlocks().add(block);
	}

	public boolean removeBlock(class_2248 block) {
		return ((BlockEntityTypeAccessor) this).getBlocks().remove(block);
	}


	public static final class Builder<T extends class_2586> {
		private final BlockEntityFactory<? extends T> factory;
		private final Set<class_2248> blocks;

		private Builder(BlockEntityFactory<? extends T> factory, Set<class_2248> blocks) {
			this.factory = factory;
			this.blocks = blocks;
		}

		public static <T extends class_2586> Builder<T> create(BlockEntityFactory<? extends T> factory, class_2248... blocks) {
			// ensure mutability
			return new Builder<>(factory, new HashSet<>(Arrays.asList(blocks)));
		}

		public MutableBlockEntityType<T> build() {
			return build(null);
		}

		public MutableBlockEntityType<T> build(Type<?> type) {
			return new MutableBlockEntityType<>(this.factory, this.blocks, type);
		}
	}


	// exists for convenience so that no access widener for BlockEntityType.BlockEntityFactory is necessary
	@FunctionalInterface
	public interface BlockEntityFactory<T extends class_2586> extends class_2591.class_5559<T> {
	}
}
