package org.dimdev.dimdoors.api.client;

import java.util.Collections;
import net.fabricmc.api.EnvType;
import net.fabricmc.api.Environment;
import net.minecraft.class_1921;
import net.minecraft.class_290;
import net.minecraft.class_293;
import net.minecraft.class_2960;
import net.minecraft.class_4587;
import net.minecraft.class_4597;
import net.minecraft.class_4668;
import net.minecraft.class_630;
import net.minecraft.class_840;
import org.dimdev.dimdoors.client.ModShaders;
import org.dimdev.dimdoors.mixin.client.accessor.RenderLayerAccessor;

@Environment(EnvType.CLIENT)
public final class DimensionalPortalRenderer {
	public static final class_2960 WARP_PATH;
	private static final class_4668.class_5942 DIMENSIONAL_PORTAL_SHADER;
	private static final class_1921 RENDER_LAYER;
	private static final class_630 MODEL;
	private static final class_630 TALL_MODEL;

	public static void renderDimensionalPortal(class_4587 matrixStack, class_4597 vertexConsumerProvider, Transformer transformer, float tickDelta, int light, int overlay) {
		renderDimensionalPortal(matrixStack, vertexConsumerProvider, transformer, tickDelta, light, overlay, true);
	}

	public static void renderDimensionalPortal(class_4587 matrixStack, class_4597 vertexConsumerProvider, Transformer transformer, float tickDelta, int light, int overlay, boolean tall) {
		class_630 model = tall ? TALL_MODEL : MODEL;
		renderModelWithPortalShader(model, matrixStack, vertexConsumerProvider, transformer, tickDelta, light, overlay);
	}

	public static void renderModelWithPortalShader(class_630 model, class_4587 matrixStack, class_4597 vertexConsumerProvider, Transformer transformer, float tickDelta, int light, int overlay) {
		transformer.transform(matrixStack);
		model.method_22698(matrixStack, vertexConsumerProvider.getBuffer(RENDER_LAYER), light, overlay);
	}

	static {
		WARP_PATH = new class_2960("dimdoors:textures/other/warp.png");
		DIMENSIONAL_PORTAL_SHADER = new class_4668.class_5942(ModShaders::getDimensionalPortal);
		RENDER_LAYER = RenderLayerFactory.create(
				"dimensional_portal",
				class_290.field_1592,
				class_293.class_5596.field_27382,
				256,
				false,
				false,
				class_1921.class_4688.method_23598()
						.method_34578(DIMENSIONAL_PORTAL_SHADER)
						.method_34577(
								class_4668.class_5940.method_34560()
										.method_34563(class_840.field_4406, false, false)
										.method_34563(WARP_PATH, false, false)
										.method_34562()
						)
						.method_23617(false)
		);
		class_630.class_628 small = new class_630.class_628(0, 0, 0.2f, 0.2f, -0.1f, 15.8f, 15.8f, 0.01F, 0, 0, 0, false, 1024, 1024);
		MODEL = new class_630(Collections.singletonList(small), Collections.emptyMap());
		class_630.class_628 big = new class_630.class_628(0, 0, 0.2f, 0.2f, -0.1f, 15.8f, 31.8f, 0.01F, 0, 0, 0, false, 1024, 1024);
		TALL_MODEL = new class_630(Collections.singletonList(big), Collections.emptyMap());
	}
}
