package org.dimdev.dimdoors.api.util;

import net.minecraft.class_1937;
import net.minecraft.class_2586;
import net.minecraft.class_3542;
import net.minecraft.class_3738;
import net.minecraft.server.MinecraftServer;
import java.util.HashMap;
import java.util.Map;
import java.util.function.BiConsumer;

public enum BlockPlacementType implements class_3542 {
	// TODO: do we need some update fluids only option?
	SECTION_NO_UPDATE_QUEUE_BLOCK_ENTITY("section_no_update_queue_block_entity", true, false, BlockPlacementType::queueBlockEntity),
	SECTION_NO_UPDATE("section_no_update", true, false, class_1937::method_8438),
	SECTION_UPDATE("section_update", true, true, class_1937::method_8438),
	SET_BLOCK_STATE("set_block_state", false, false, class_1937::method_8438),
	SET_BLOCK_STATE_QUEUE_BLOCK_ENTITY("set_block_state_queue_block_entity", false, false, BlockPlacementType::queueBlockEntity);

	private final static Map<String, BlockPlacementType> idMap = new HashMap<>();

	public static final class_7292<BlockPlacementType> CODEC = class_3542.method_28140(BlockPlacementType::values);

	static {
		for (BlockPlacementType type : BlockPlacementType.values()) {
			idMap.put(type.getId(), type);
		}
	}

	final String id;
	final boolean useSection;
	final boolean markForUpdate;
	final BiConsumer<class_1937, class_2586> blockEntityPlacer;


	BlockPlacementType(String id, boolean useSection, boolean markForUpdate, BiConsumer<class_1937, class_2586> blockEntityPlacer) {
		this.id = id;
		this.useSection = useSection;
		this.markForUpdate = markForUpdate;
		this.blockEntityPlacer = blockEntityPlacer;
	}

	public boolean useSection() {
		return useSection;
	}

	public boolean shouldMarkForUpdate() {
		return markForUpdate;
	}

	public BiConsumer<class_1937, class_2586> getBlockEntityPlacer() {
		return blockEntityPlacer;
	}

	public String getId() {
		return id;
	}

	public static BlockPlacementType getFromId(String id) {
		return idMap.get(id);
	}

	private static void queueBlockEntity(class_1937 world, class_2586 blockEntity) {
		MinecraftServer server = world.method_8503();
		server.method_18858(new class_3738(server.method_3780(), () -> world.method_8438(blockEntity)));
	}

	@Override
	public String method_15434() {
		return id;
	}
}
