package org.dimdev.dimdoors.api.util;

import com.mojang.serialization.Codec;
import com.mojang.serialization.codecs.RecordCodecBuilder;
import net.minecraft.class_1937;
import net.minecraft.class_2338;
import net.minecraft.class_2378;
import net.minecraft.class_2487;
import net.minecraft.class_2586;
import net.minecraft.class_2680;
import net.minecraft.class_2960;
import net.minecraft.class_3218;
import net.minecraft.class_3610;
import net.minecraft.class_5321;
import org.dimdev.dimdoors.DimensionalDoorsInitializer;

public class Location {
	public static final Codec<Location> CODEC = RecordCodecBuilder.create(instance -> {
		return instance.group(class_1937.field_25178.fieldOf("world").forGetter(location -> {
			return location.world;
		}), class_2338.field_25064.fieldOf("pos").forGetter(location -> {
			return location.pos;
		})).apply(instance, Location::new);
	});

	public final class_5321<class_1937> world;
	public final class_2338 pos;

	public Location(class_5321<class_1937> world, class_2338 pos) {
		this.world = world;
		this.pos = pos;
	}

	public Location(class_3218 world, int x, int y, int z) {
		this(world, new class_2338(x, y, z));
	}

	public Location(class_3218 world, class_2338 pos) {
		this(world.method_27983(), pos);
	}

	public int getX() {
		return this.pos.method_10263();
	}

	public int getY() {
		return this.pos.method_10264();
	}

	public int getZ() {
		return this.pos.method_10260();
	}

	public class_2680 getBlockState() {
		return this.getWorld().method_8320(this.pos);
	}

	public class_3610 getFluidState() {
		return this.getWorld().method_8316(this.pos);
	}

	public class_2586 getBlockEntity() {
		return this.getWorld().method_8321(this.pos);
	}

	public class_2338 getBlockPos() {
		return this.pos;
	}

	@Override
	public boolean equals(Object obj) {
		return obj instanceof Location &&
				((Location) obj).world.equals(this.world) &&
				((Location) obj).pos.equals(this.pos);
	}

	@Override
	public int hashCode() {
		return this.world.hashCode() * 31 + this.pos.hashCode();
	}

	public class_5321<class_1937> getWorldId() {
		return this.world;
	}

	public class_3218 getWorld() {
		return DimensionalDoorsInitializer.getServer().method_3847(this.world);
	}

	public static class_2487 toNbt(Location location) {
		class_2487 nbt = new class_2487();
		nbt.method_10582("world", location.world.method_29177().toString());
		nbt.method_10539("pos", new int[]{location.getX(), location.getY(), location.getZ()});
		return nbt;
	}

	public static Location fromNbt(class_2487 nbt) {
		int[] pos = nbt.method_10561("pos");
		return new Location(
				class_5321.method_29179(class_2378.field_25298, new class_2960(nbt.method_10558("world"))),
				new class_2338(pos[0], pos[1], pos[2])
		);
	}
}
