package org.dimdev.dimdoors.api.util;

import java.util.Map;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.dimdev.dimdoors.api.util.math.Equation;
import net.fabricmc.fabric.api.util.NbtType;
import net.minecraft.class_2487;
import net.minecraft.class_2499;
import net.minecraft.class_2520;

public class NbtEquations {
	private static final Logger LOGGER = LogManager.getLogger();

	public static class_2487 solveNbtCompoundEquations(class_2487 nbt, Map<String, Double> variableMap) {
		class_2487 solved = new class_2487();
		for (String key : nbt.method_10541()) {
			if (nbt.method_10540(key) == NbtType.STRING && key.startsWith("equation_")) {
				try {
					double solution = Equation.parse(nbt.method_10558(key)).apply(variableMap);
					key = key.substring(9);
					if (key.startsWith("int_")) {
						key = key.substring(4);
						solved.method_10569(key, (int) solution);
					} else if (key.startsWith("boolean_")) {
						key = key.substring(8);
						solved.method_10556(key, Equation.toBoolean(solution));
					} else if (key.startsWith("double_")) {
						key = key.substring(7);
						solved.method_10549(key, solution);
					} else {
						solved.method_10549(key, solution);
					}
				} catch (Equation.EquationParseException e) {
					LOGGER.error(e);
				}
			} else if (nbt.method_10540(key) == NbtType.COMPOUND) {
				solved.method_10566(key, solveNbtCompoundEquations(nbt.method_10562(key), variableMap));
			} else if (nbt.method_10540(key) == NbtType.LIST) {
				solved.method_10566(key, solveNbtListEquations((class_2499) nbt.method_10580(key), variableMap));
			} else {
				solved.method_10566(key, nbt.method_10580(key));
			}
		}
		return solved;
	}

	public static class_2499 solveNbtListEquations(class_2499 nbtList, Map<String, Double> variableMap) {
		class_2499 solved = new class_2499();
		for (class_2520 nbt : nbtList) {
			if (nbt.method_10711() == NbtType.LIST) {
				solved.add(solveNbtListEquations((class_2499) nbt, variableMap));
			} else if (nbt.method_10711() == NbtType.COMPOUND) {
				solved.add(solveNbtCompoundEquations((class_2487) nbt, variableMap));
			} else {
				solved.add(nbt);
			}
		}
		return solved;
	}
}
