package org.dimdev.dimdoors.api.util;

import net.fabricmc.fabric.api.dimension.v1.FabricDimensions;
import net.minecraft.class_1297;
import net.minecraft.class_1657;
import net.minecraft.class_1923;
import net.minecraft.class_1937;
import net.minecraft.class_2338;
import net.minecraft.class_2379;
import net.minecraft.class_243;
import net.minecraft.class_2743;
import net.minecraft.class_3218;
import net.minecraft.class_3222;
import net.minecraft.class_3230;
import net.minecraft.class_3532;
import net.minecraft.class_5454;
import net.minecraft.util.math.*;
import org.dimdev.dimdoors.DimensionalDoorsInitializer;
import org.dimdev.dimdoors.entity.stat.ModStats;
import org.dimdev.dimdoors.network.ExtendedServerPlayNetworkHandler;
import org.dimdev.dimdoors.world.ModDimensions;

import java.util.concurrent.ThreadLocalRandom;

@SuppressWarnings("deprecation")
public final class TeleportUtil {
	public static  <E extends class_1297> E teleport(E entity, class_1937 world, class_2338 pos, float yaw) {
		return teleport(entity, world, class_243.method_24955(pos), yaw);
	}

	public static  <E extends class_1297> E teleport(E entity, class_1937 world, class_243 pos, float yaw) {
		return teleport(entity, world, pos, new class_2379(entity.method_36455(), yaw, 0), entity.method_18798());
	}

	public static  <E extends class_1297> E teleport(E entity, class_1937 world, class_243 pos, class_2379 angle, class_243 velocity) {
		if (world.field_9236) {
			throw new UnsupportedOperationException("Only supported on ServerWorld");
		}

		// Some insurance
		float yaw = class_3532.method_15393(angle.method_10257());
		float pitch = class_3532.method_15363(class_3532.method_15393(angle.method_10256()), -90.0F, 90.0F);

		if (entity instanceof class_3222) {
			// This is what the vanilla tp command does. Let's hope this works.
			class_1923 chunkPos = new class_1923(new class_2338(pos));
			((class_3218) world).method_14178().method_17297(class_3230.field_19347, chunkPos, 1, entity.method_5628());
			entity.method_5848();


			if (entity.field_6002.method_27983().equals(world.method_27983())) {
				((class_3222) entity).field_13987.method_14363(pos.method_10216(), pos.method_10214(), pos.method_10215(), yaw, pitch);
			} else {
				entity = FabricDimensions.teleport(entity, (class_3218) world, new class_5454(pos, velocity, yaw, pitch));
			}

			((class_3222) entity).field_13987.method_14364(new class_2743(entity.method_5628(), velocity));
			((ExtendedServerPlayNetworkHandler) ((class_3222) entity).field_13987).getDimDoorsPacketHandler().syncPocketAddonsIfNeeded(world, new class_2338(pos));

			if (world.method_27983() == ModDimensions.DUNGEON) {
				((class_1657) entity).method_7281(ModStats.TIMES_BEEN_TO_DUNGEON);
			}
		} else {
			if (entity.field_6002.method_27983().equals(world.method_27983())) {
				entity.method_5808(pos.method_10216(), pos.method_10214(), pos.method_10215(), yaw, pitch);
			} else {
				entity = FabricDimensions.teleport(entity, (class_3218) world, new class_5454(pos, velocity, yaw, pitch));
			}
		}
		entity.method_18799(velocity);

		return entity;
	}

	public static  <E extends class_1297> E teleport(E entity, class_1937 world, class_2338 pos, class_2379 angle, class_243 velocity) {
		if (world.field_9236) {
			throw new UnsupportedOperationException("Only supported on ServerWorld");
		}

		return teleport(entity, world, class_243.method_24955(pos), angle, velocity);
	}

	public static class_3222 teleport(class_3222 player, Location location) {
		return teleport(player, DimensionalDoorsInitializer.getWorld(location.world), location.pos, 0);
	}

	public static class_3222 teleport(class_3222 player, RotatedLocation location) {
		return teleport(player, DimensionalDoorsInitializer.getWorld(location.world), location.pos, (int) location.yaw);
	}
	public static  <E extends class_1297> E teleportRandom(E entity, class_1937 world, double y) {
		double scale = ThreadLocalRandom.current().nextGaussian() * ThreadLocalRandom.current().nextInt(90);
		return teleport(
				entity,
				world,
				entity.method_19538()
						.method_1023(0, entity.method_23318(), 0)
						.method_1031(0, y, 0)
						.method_18805(scale, 1, scale),
				entity.method_36454()
		);
	}

	public static  <E extends class_1297> E teleportUntargeted(E entity, class_1937 world) {
		double actualScale = entity.field_6002.method_8597().comp_646() / world.method_8597().comp_646();
		return teleport(
				entity,
				world,
				entity.method_19538().method_18805(actualScale, 1, actualScale),
				entity.method_36454()
		);
	}

	public static  <E extends class_1297> E teleportUntargeted(E entity, class_1937 world, double y) {
		double actualScale = entity.field_6002.method_8597().comp_646() / world.method_8597().comp_646();
		return teleport(
				entity,
				world,
				entity.method_19538()
						.method_1023(0, entity.method_19538().method_10214(), 0)
						.method_1031(0, y, 0)
						.method_18805(actualScale, 1, actualScale),
				entity.method_36454()
		);
	}
}
