package org.dimdev.dimdoors.block;

import net.minecraft.class_2338;
import net.minecraft.class_2379;
import net.minecraft.class_243;
import net.minecraft.class_2680;
import org.dimdev.dimdoors.api.util.math.TransformationMatrix3d;

public interface CoordinateTransformerBlock {
	TransformationMatrix3d.TransformationMatrix3dBuilder transformationBuilder(class_2680 state, class_2338 pos);

	TransformationMatrix3d.TransformationMatrix3dBuilder rotatorBuilder(class_2680 state, class_2338 pos);

	default class_243 transformTo(TransformationMatrix3d.TransformationMatrix3dBuilder transformationBuilder, class_243 vector) {
		return transformationBuilder.build().transform(vector);
	}

	default class_243 transformOut(TransformationMatrix3d.TransformationMatrix3dBuilder transformationBuilder, class_243 vector) {
		return transformationBuilder.buildReverse().transform(vector);
	}

	default class_2379 rotateTo(TransformationMatrix3d.TransformationMatrix3dBuilder rotatorBuilder, class_2379 angle) {
		return rotatorBuilder.build().transform(angle);
	}

	default class_243 rotateTo(TransformationMatrix3d.TransformationMatrix3dBuilder rotatorBuilder, class_243 vector) {
		return rotatorBuilder.build().transform(vector);
	}

	default class_2379 rotateOut(TransformationMatrix3d.TransformationMatrix3dBuilder rotatorBuilder, class_2379 angle) {
		return rotatorBuilder.buildReverse().transform(angle);
	}

	default class_243 rotateOut(TransformationMatrix3d.TransformationMatrix3dBuilder rotatorBuilder, class_243 vector) {
		return rotatorBuilder.buildReverse().transform(vector);
	}

	default boolean isExitFlipped() {
		return false;
	}
}
