package org.dimdev.dimdoors.block;

import net.minecraft.block.*;
import net.minecraft.class_1922;
import net.minecraft.class_1937;
import net.minecraft.class_2248;
import net.minecraft.class_2338;
import net.minecraft.class_2464;
import net.minecraft.class_2586;
import net.minecraft.class_259;
import net.minecraft.class_2591;
import net.minecraft.class_265;
import net.minecraft.class_2680;
import net.minecraft.class_3620;
import net.minecraft.class_3726;
import net.minecraft.class_3737;
import net.minecraft.class_5558;
import net.minecraft.class_5819;
import org.dimdev.dimdoors.block.entity.DetachedRiftBlockEntity;
import org.dimdev.dimdoors.block.entity.ModBlockEntityTypes;
import org.dimdev.dimdoors.particle.client.RiftParticleEffect;
import org.dimdev.dimdoors.world.ModDimensions;
import org.jetbrains.annotations.Nullable;
import net.fabricmc.api.EnvType;
import net.fabricmc.api.Environment;

public class DetachedRiftBlock extends WaterLoggableBlockWithEntity implements RiftProvider<DetachedRiftBlockEntity>, class_3737 {
	public static final String ID = "rift";
	public DetachedRiftBlock(class_2248.Settings settings) {
		super(settings);
	}

	@Override
	public class_3620 method_26403() {
		return class_3620.field_16009;
	}

	@Override
	public DetachedRiftBlockEntity getRift(class_1937 world, class_2338 pos, class_2680 state) {
		return (DetachedRiftBlockEntity) world.method_8321(pos);
	}

	@Override
	@Environment(EnvType.CLIENT)
	public void method_9496(class_2680 state, class_1937 world, class_2338 pos, class_5819 rand) {
		class_2586 blockEntity = world.method_8321(pos);
		// randomDisplayTick can be called before the tile entity is created in multiplayer
		if (!(blockEntity instanceof DetachedRiftBlockEntity)) return;
		DetachedRiftBlockEntity rift = (DetachedRiftBlockEntity) blockEntity;

		boolean outsidePocket = !ModDimensions.isPocketDimension(world);
		double speed = 0.1;

		if (rift.closing) {
			world.method_8406(RiftParticleEffect.of(outsidePocket),
					pos.method_10263() + .5,
					pos.method_10264() + .5,
					pos.method_10260() + .5,
					rand.method_43059() * speed,
					rand.method_43059() * speed,
					rand.method_43059() * speed
			);
		}

		world.method_8406(RiftParticleEffect.of(outsidePocket, rift.stabilized),
				pos.method_10263() + .5,
				pos.method_10264() + .5,
				pos.method_10260() + .5,
				rand.method_43059() * speed,
				rand.method_43059() * speed,
				rand.method_43059() * speed
		);
	}

	@Override
	public class_2464 method_9604(class_2680 state) {
		return class_2464.field_11456;
	}

	@Override
	public class_265 method_9584(class_2680 state, class_1922 world, class_2338 pos) {
		return class_259.method_1077();
	}

	public class_265 method_9530(class_2680 state, class_1922 world, class_2338 pos, class_3726 context) {
		return class_259.method_1077();
	}

	@Nullable
	@Override
	public class_2586 method_10123(class_2338 pos, class_2680 state) {
		return new DetachedRiftBlockEntity(pos, state);
	}

	@Nullable
	@Override
	public <T extends class_2586> class_5558<T> method_31645(class_1937 world, class_2680 state, class_2591<T> type) {
		return method_31618(type, ModBlockEntityTypes.DETACHED_RIFT, DetachedRiftBlockEntity::tick);
	}
}
