package org.dimdev.dimdoors.block;

import org.apache.logging.log4j.Level;
import org.dimdev.dimdoors.api.util.Location;
import org.dimdev.dimdoors.block.entity.DetachedRiftBlockEntity;
import org.dimdev.dimdoors.block.entity.EntranceRiftBlockEntity;
import org.dimdev.dimdoors.block.entity.ModBlockEntityTypes;
import org.dimdev.dimdoors.world.level.registry.DimensionalRegistry;
import org.jetbrains.annotations.Nullable;
import net.fabricmc.api.EnvType;
import net.fabricmc.api.Environment;
import net.minecraft.class_1297;
import net.minecraft.class_1922;
import net.minecraft.class_1937;
import net.minecraft.class_2237;
import net.minecraft.class_2248;
import net.minecraft.class_2338;
import net.minecraft.class_2350;
import net.minecraft.class_2383;
import net.minecraft.class_2415;
import net.minecraft.class_2464;
import net.minecraft.class_2470;
import net.minecraft.class_2586;
import net.minecraft.class_259;
import net.minecraft.class_2591;
import net.minecraft.class_265;
import net.minecraft.class_2680;
import net.minecraft.class_2689;
import net.minecraft.class_2753;
import net.minecraft.class_3218;
import net.minecraft.class_5558;

// TODO: copy over all the necessary bits from DimensionalDoorBlock
public class DimensionalPortalBlock extends class_2248 implements RiftProvider<EntranceRiftBlockEntity> {
	public static class_2753 FACING = class_2383.field_11177;

	public DimensionalPortalBlock(class_2251 settings) {
		super(settings);
		this.method_9590(this.field_10647.method_11664().method_11657(FACING, class_2350.field_11043));
	}

	@Override
	public EntranceRiftBlockEntity getRift(class_1937 world, class_2338 pos, class_2680 state) {
		return (EntranceRiftBlockEntity) world.method_8321(pos);
	}

	@Nullable
	@Override
	public class_2586 method_10123(class_2338 pos, class_2680 state) {
		return new EntranceRiftBlockEntity(pos, state);
	}

	@Override
	public class_2464 method_9604(class_2680 state) {
		return class_2464.field_11456;
	}

	@Override
	public void method_9548(class_2680 state, class_1937 world, class_2338 pos, class_1297 entity) {
		if (world.field_9236) {
			return;
		}

		this.getRift(world, pos, state).teleport(entity);

		EntranceRiftBlockEntity rift = this.getRift(world, pos, state);

		world.method_8501(pos, ModBlocks.DETACHED_RIFT.method_9564());
		((DetachedRiftBlockEntity) world.method_8321(pos)).setData(rift.getData());

		/*
		New plan, we use players spawn points as the exit points from limbo, this code will no longer be used.
		DimensionalRegistry.getRiftRegistry().setOverworldRift(entity.getUuid(), new Location((ServerWorld) world, pos));
		LOGGER.log(Level.INFO, "Set overworld rift location");

		 */

	}

	public class_2680 method_9598(class_2680 state, class_2470 rotation) {
		return state.method_11657(FACING, rotation.method_10503(state.method_11654(FACING)));
	}

	public class_2680 method_9569(class_2680 state, class_2415 mirror) {
		return state.method_26186(mirror.method_10345(state.method_11654(FACING)));
	}

	protected void method_9515(class_2689.class_2690<class_2248, class_2680> builder) {
		builder.method_11667(FACING);
	}

	@Override
	public class_265 method_9584(class_2680 state, class_1922 world, class_2338 pos) {
		return class_259.method_1077();
	}

	@Environment(EnvType.CLIENT)
	@Override
	public boolean isTall(class_2680 cachedState) {
		return true;
	}

	@Override
	public void method_9615(class_2680 state, class_1937 world, class_2338 pos, class_2680 oldState, boolean notify) {
		if (world.field_9236) return;
		((EntranceRiftBlockEntity) world.method_8321(pos)).setPortalDestination((class_3218) world);
	}

	@Nullable
	@Override
	public <T extends class_2586> class_5558<T> method_31645(class_1937 world, class_2680 state, class_2591<T> type) {
		return Dummy.method_31618(type, ModBlockEntityTypes.ENTRANCE_RIFT, DimensionalPortalBlock::portalTick);
	}

	private static void portalTick(class_1937 world, class_2338 pos, class_2680 state, EntranceRiftBlockEntity e) {
		if (world.field_9236 || e.getDestination() != null) {
			return;
		}
		e.setPortalDestination((class_3218) world);
	}

	private static final class Dummy extends class_2237 {
		protected Dummy(class_2251 settings) {
			super(settings);
		}

		@Nullable
		protected static <E extends class_2586, A extends class_2586> class_5558<A> method_31618(class_2591<A> givenType, class_2591<E> expectedType, class_5558<? super E> ticker) {
			return class_2237.method_31618(givenType, expectedType, ticker);
		}

		@Nullable
		@Override
		public class_2586 method_10123(class_2338 pos, class_2680 state) {
			return null;
		}
	}
}
