package org.dimdev.dimdoors.block.door.data.condition;

import java.util.Objects;
import java.util.function.Function;

import com.google.gson.JsonObject;
import com.mojang.serialization.Lifecycle;
import org.dimdev.dimdoors.DimensionalDoorsInitializer;
import org.dimdev.dimdoors.block.entity.EntranceRiftBlockEntity;
import net.fabricmc.fabric.api.event.registry.FabricRegistryBuilder;
import net.minecraft.class_2370;
import net.minecraft.class_2378;
import net.minecraft.class_2960;
import net.minecraft.class_5321;

public interface Condition {
	class_2378<ConditionType<?>> REGISTRY = FabricRegistryBuilder.<ConditionType<?>, class_2370<ConditionType<?>>>from(new class_2370<>(class_5321.method_29180(new class_2960("dimdoors", "rift_data_condition")), Lifecycle.stable(), null)).buildAndRegister();

	boolean matches(EntranceRiftBlockEntity rift);

	default JsonObject toJson(JsonObject json) {
		json.addProperty("type", getType().getId());
		this.toJsonInner(json);
		return json;
	}

	void toJsonInner(JsonObject json);

	ConditionType<?> getType();

	static Condition fromJson(JsonObject json) {
		class_2960 type = new class_2960(json.getAsJsonPrimitive("type").getAsString());
		return Objects.requireNonNull(REGISTRY.method_10223(type)).fromJson(json);
	}

	interface ConditionType<T extends Condition> {
		ConditionType<AlwaysTrueCondition> ALWAYS_TRUE = register("always_true", j -> AlwaysTrueCondition.INSTANCE);
		ConditionType<AllCondition> ALL = register("all", AllCondition::fromJson);
		ConditionType<AnyCondition> ANY = register("any", AnyCondition::fromJson);
		ConditionType<InverseCondition> INVERSE = register("inverse", InverseCondition::fromJson);
		ConditionType<WorldMatchCondition> WORLD_MATCH = register("world_match", WorldMatchCondition::fromJson);

		T fromJson(JsonObject json);

		default String getId() {
			return String.valueOf(REGISTRY.method_10221(this));
		}

		static void register() {
			DimensionalDoorsInitializer.apiSubscribers.forEach(d -> d.registerConditionTypes(REGISTRY));
		}

		static <T extends Condition> ConditionType<T> register(String name, Function<JsonObject, T> fromJson) {
			return class_2378.method_10230(REGISTRY, new class_2960("dimdoors", name), json -> fromJson.apply(json));
		}
	}
}
