package org.dimdev.dimdoors.block.entity;

import org.dimdev.dimdoors.rift.registry.LinkProperties;
import org.dimdev.dimdoors.rift.targets.VirtualTarget;
import net.minecraft.class_2487;
import org.dimdev.dimdoors.api.util.RGBA;

public class RiftData {
	private VirtualTarget destination = VirtualTarget.NoneTarget.INSTANCE; // How the rift acts as a source
	private LinkProperties properties = null;
	private boolean alwaysDelete;
	private boolean forcedColor;
	private RGBA color = RGBA.NONE;

	public RiftData() {
	}

	public VirtualTarget getDestination() {
		return this.destination;
	}

	public void setDestination(VirtualTarget destination) {
		this.destination = destination;
	}

	public LinkProperties getProperties() {
		return this.properties;
	}

	public void setProperties(LinkProperties properties) {
		this.properties = properties;
	}

	public boolean isAlwaysDelete() {
		return this.alwaysDelete;
	}

	public void setAlwaysDelete(boolean alwaysDelete) {
		this.alwaysDelete = alwaysDelete;
	}

	public boolean isForcedColor() {
		return this.forcedColor;
	}

	public void setForcedColor(boolean forcedColor) {
		this.forcedColor = forcedColor;
	}

	public RGBA getColor() {
		return this.color;
	}

	public void setColor(RGBA color) {
		this.forcedColor = color != null;
		this.color = color;
	}

	public static class_2487 toNbt(RiftData data) {
		class_2487 nbt = new class_2487();
		if (data.destination != VirtualTarget.NoneTarget.INSTANCE) nbt.method_10566("destination", VirtualTarget.toNbt(data.destination));
		if (data.properties != null) nbt.method_10566("properties", LinkProperties.toNbt(data.properties));
		if (data.color != null) nbt.method_10566("color", RGBA.toNbt(data.color));
		nbt.method_10556("alwaysDelete", data.alwaysDelete);
		nbt.method_10556("forcedColor", data.forcedColor);
		return nbt;
	}

	public static RiftData fromNbt(class_2487 nbt) {
		RiftData data = new RiftData();
		data.destination = nbt.method_10545("destination") ? VirtualTarget.fromNbt(nbt.method_10562("destination")) : VirtualTarget.NoneTarget.INSTANCE;
		data.properties = nbt.method_10545("properties") ? LinkProperties.fromNbt(nbt.method_10562("properties")) : null;
		data.alwaysDelete = nbt.method_10577("alwaysDelete");
		data.forcedColor = nbt.method_10577("forcedColor");
		data.color = nbt.method_10545("color") ? RGBA.fromNbt(nbt.method_10562("color")) : RGBA.NONE;
		return data;
	}
}
