package org.dimdev.dimdoors.client;

import java.util.Objects;

import com.flowpowered.math.TrigMath;
import org.dimdev.dimdoors.DimensionalDoorsInitializer;
import org.dimdev.dimdoors.block.entity.DetachedRiftBlockEntity;
import org.dimdev.dimdoors.block.entity.RiftBlockEntity;
import org.dimdev.dimdoors.client.tesseract.Tesseract;
import org.dimdev.dimdoors.api.util.RGBA;
import net.fabricmc.api.EnvType;
import net.fabricmc.api.Environment;
import net.minecraft.class_1268;
import net.minecraft.class_2561;
import net.minecraft.class_2960;
import net.minecraft.class_310;
import net.minecraft.class_4587;
import net.minecraft.class_4588;
import net.minecraft.class_4597;
import net.minecraft.class_765;
import net.minecraft.class_827;
import org.dimdev.dimdoors.item.ModItems;
import org.dimdev.dimdoors.rift.targets.IdMarker;

@Environment(EnvType.CLIENT)
public class DetachedRiftBlockEntityRenderer implements class_827<DetachedRiftBlockEntity> {
    public static final class_2960 TESSERACT_PATH = new class_2960("dimdoors:textures/other/tesseract.png");
    private static final RGBA DEFAULT_COLOR = new RGBA(1, 0.5f, 1, 1);

    private static final Tesseract TESSERACT = new Tesseract();
    private static final RiftCurves.PolygonInfo CURVE = RiftCurves.CURVES.get(0);

    @Override
    public void render(DetachedRiftBlockEntity rift, float tickDelta, class_4587 matrices, class_4597 vcs, int breakProgress, int alpha) {
		if(class_310.method_1551().field_1724 != null && class_310.method_1551().field_1724.method_5998(class_1268.field_5808).method_31574(ModItems.RIFT_CONFIGURATION_TOOL) && rift.getData().getDestination() instanceof IdMarker idMarker) {
			matrices.method_22903();
			matrices.method_22904(0.5, 0.5, 0.5);

			class_310.method_1551().field_1772.method_30882(class_2561.method_30163(String.valueOf(idMarker.getId())), 0f,0f, 0xffffffff, false, matrices.method_23760().method_23761(), vcs, true, 0x000000, class_765.field_32767);

			matrices.method_22909();
		}

    	if (DimensionalDoorsInitializer.getConfig().getGraphicsConfig().showRiftCore) {
            this.renderTesseract(vcs.getBuffer(MyRenderLayer.TESSERACT), rift, matrices, tickDelta);
        } else {
            long timeLeft = RiftBlockEntity.showRiftCoreUntil - System.currentTimeMillis();
            if (timeLeft >= 0) {
                this.renderTesseract(vcs.getBuffer(MyRenderLayer.TESSERACT), rift, matrices, tickDelta);
            }
        }

        this.renderCrack(vcs.getBuffer(MyRenderLayer.CRACK), matrices, rift);
    }

    private void renderCrack(class_4588 vc, class_4587 matrices, DetachedRiftBlockEntity rift) {
        matrices.method_22903();
        matrices.method_22904(0.5, 0.5, 0.5);
        RiftCrackRenderer.drawCrack(matrices.method_23760().method_23761(), vc, 0, CURVE, DimensionalDoorsInitializer.getConfig().getGraphicsConfig().riftSize * rift.size / 150, 0);//0xF1234568L * rift.hashCode());
        matrices.method_22909();
    }

    private void renderTesseract(class_4588 vc, DetachedRiftBlockEntity rift, class_4587 matrices, float tickDelta) {
        double radian = this.nextAngle(rift, tickDelta) * TrigMath.DEG_TO_RAD;
        RGBA color = rift.getColor();
        if (Objects.equals(color, RGBA.NONE)) {
            color = DEFAULT_COLOR;
        }

        matrices.method_22903();

        matrices.method_22904(0.5, 0.5, 0.5);
        matrices.method_22905(0.25f, 0.25f, 0.25f);

        TESSERACT.draw(matrices.method_23760().method_23761(), vc, color, radian);

        matrices.method_22909();
    }

    private double nextAngle(DetachedRiftBlockEntity rift, float tickDelta) {
        rift.renderAngle = (rift.renderAngle + 5 * tickDelta) % 360;
        return rift.renderAngle;
    }
}
