package org.dimdev.dimdoors.client;

import com.mojang.blaze3d.systems.RenderSystem;
import net.fabricmc.fabric.api.client.rendering.v1.DimensionRenderingRegistry;
import net.minecraft.class_1159;
import net.minecraft.class_1937;
import net.minecraft.class_287;
import net.minecraft.class_289;
import net.minecraft.class_290;
import net.minecraft.class_293;
import net.minecraft.class_2960;
import net.minecraft.class_4587;
import net.minecraft.class_5321;
import net.minecraft.class_638;
import net.minecraft.class_757;
import net.minecraft.client.render.*;
import org.dimdev.dimdoors.listener.pocket.PocketListenerUtil;
import org.dimdev.dimdoors.world.ModDimensions;
import org.dimdev.dimdoors.world.pocket.type.addon.SkyAddon;

import java.util.List;

public class DimensionRenderering {
    private static final class_2960 MOON_RENDER_PATH = new class_2960("dimdoors:textures/other/limbo_moon.png");
    private static final class_2960 SUN_RENDER_PATH = new class_2960("dimdoors:textures/other/limbo_sun.png");

    public static void initClient() {
        DimensionRenderingRegistry.CloudRenderer noCloudRenderer = context -> {
        };
        DimensionRenderingRegistry.registerCloudRenderer(ModDimensions.LIMBO, noCloudRenderer);
        DimensionRenderingRegistry.registerCloudRenderer(ModDimensions.DUNGEON, noCloudRenderer);
        DimensionRenderingRegistry.registerCloudRenderer(ModDimensions.PERSONAL, noCloudRenderer);
        DimensionRenderingRegistry.registerCloudRenderer(ModDimensions.PUBLIC, noCloudRenderer);

        DimensionRenderingRegistry.registerSkyRenderer(ModDimensions.LIMBO, context -> renderLimboSky(context.matrixStack()));

        DimensionRenderingRegistry.SkyRenderer pocketRenderer = context -> {
            class_638 world = context.world();
            class_4587 matrices = context.matrixStack();
            List<SkyAddon> skyAddons = PocketListenerUtil.applicableAddonsClient(SkyAddon.class, world, context.camera().method_19328());
            SkyAddon skyAddon = null;
            if (skyAddons.size() > 0) {
                // There should really only be one of these.
                // If anyone needs to use multiple SkyAddons then go ahead and change this.
                skyAddon = skyAddons.get(0);
            }

            if (skyAddon != null) {
                class_5321<class_1937> key = skyAddon.getWorld();

                DimensionRenderingRegistry.SkyRenderer skyRenderer = DimensionRenderingRegistry.getSkyRenderer(key);

                if (skyRenderer != null) {
                    skyRenderer.render(context);
                } else {

                    if (key.equals(class_1937.field_25181)) {
                        context.gameRenderer().method_35772().field_1769.method_3250(matrices);
                    } else if (key.equals(ModDimensions.LIMBO)) {
                        renderLimboSky(matrices);
                    }
                }
            }
        };

        DimensionRenderingRegistry.registerSkyRenderer(ModDimensions.DUNGEON, pocketRenderer);
        DimensionRenderingRegistry.registerSkyRenderer(ModDimensions.PERSONAL, pocketRenderer);
        DimensionRenderingRegistry.registerSkyRenderer(ModDimensions.PUBLIC, pocketRenderer);
    }

    private static void renderLimboSky(class_4587 matrices) {
        class_1159 matrix4f = matrices.method_23760().method_23761();
        class_289 tessellator = class_289.method_1348();
        class_287 bufferBuilder = tessellator.method_1349();
        RenderSystem.enableBlend();
        RenderSystem.defaultBlendFunc();
        RenderSystem.depthMask(false);
        RenderSystem.setShader(class_757::method_34543);
        RenderSystem.setShaderColor(1, 1, 1, 1);

        float s = 30.0F;
        RenderSystem.setShader(class_757::method_34542);
        RenderSystem.setShaderTexture(0, SUN_RENDER_PATH);
        bufferBuilder.method_1328(class_293.class_5596.field_27382, class_290.field_1585);
        bufferBuilder.method_22918(matrix4f, -s, 100.0F, -s).method_22913(0.0F, 0.0F).method_1344();
        bufferBuilder.method_22918(matrix4f, s, 100.0F, -s).method_22913(1.0F, 0.0F).method_1344();
        bufferBuilder.method_22918(matrix4f, s, 100.0F, s).method_22913(1.0F, 1.0F).method_1344();
        bufferBuilder.method_22918(matrix4f, -s, 100.0F, s).method_22913(0.0F, 1.0F).method_1344();
		tessellator.method_1350();
//        BufferRenderer.draw(bufferBuilder);
        RenderSystem.setShaderTexture(0, MOON_RENDER_PATH);
        bufferBuilder.method_1328(class_293.class_5596.field_27382, class_290.field_1585);
        bufferBuilder.method_22918(matrix4f, -s, -100.0F, -s).method_22913(0.0F, 0.0F).method_1344();
        bufferBuilder.method_22918(matrix4f, s, -100.0F, -s).method_22913(1.0F, 0.0F).method_1344();
        bufferBuilder.method_22918(matrix4f, s, -100.0F, s).method_22913(1.0F, 1.0F).method_1344();
        bufferBuilder.method_22918(matrix4f, -s, -100.0F, s).method_22913(0.0F, 1.0F).method_1344();
		tessellator.method_1350();
//        BufferRenderer.draw(bufferBuilder);

        RenderSystem.depthMask(true);
        RenderSystem.enableTexture();
        RenderSystem.disableBlend();
    }

}
