package org.dimdev.dimdoors.client;

import net.fabricmc.fabric.api.client.model.ModelProviderContext;
import net.fabricmc.fabric.api.client.model.ModelProviderException;
import net.fabricmc.fabric.api.client.model.ModelVariantProvider;
import net.minecraft.class_1091;
import net.minecraft.class_1100;
import net.minecraft.class_2248;
import net.minecraft.class_2378;
import net.minecraft.class_2769;
import net.minecraft.class_2960;
import org.dimdev.dimdoors.DimensionalDoorsInitializer;
import org.dimdev.dimdoors.block.door.DimensionalDoorBlockRegistrar;
import org.dimdev.dimdoors.item.DimensionalDoorItemRegistrar;
import org.jetbrains.annotations.Nullable;

import java.util.ArrayList;
import java.util.Set;
import java.util.stream.Collectors;

public class DimensionalDoorModelVariantProvider implements ModelVariantProvider {
	private static final class_2960 childItem = new class_2960("dimdoors:item/child_item");

	@Override
	public @Nullable class_1100 loadModelVariant(class_1091 modelId, ModelProviderContext context) throws ModelProviderException {
		class_2960 identifier = new class_2960(modelId.method_12836(), modelId.method_12832());

		DimensionalDoorBlockRegistrar blockRegistrar = DimensionalDoorsInitializer.getDimensionalDoorBlockRegistrar();
		if (blockRegistrar.isMapped(identifier)) {
			class_2960 mapped = blockRegistrar.get(identifier);
			//ModelIdentifier newId = new ModelIdentifier(mapped, modelId.getVariant());
			//UnbakedModel model = context.loadModel(newId);
			//if (model != null) return model;

			class_2248 original = class_2378.field_11146.method_10223(mapped);
			Set<String> originalProperties = original.method_9595().method_11659().stream().map(class_2769::method_11899).collect(Collectors.toSet());

			ArrayList<String> variantArray = new ArrayList<>();
			for (String part : modelId.method_4740().split(",")) {
				if (originalProperties.contains(part.split("=")[0])) variantArray.add(part);
			}
			String variant = String.join(",", variantArray);
			class_1091 newId = new class_1091(mapped, variant);
			return context.loadModel(newId);
		} else if (identifier.method_12832().startsWith(DimensionalDoorItemRegistrar.PREFIX)) {
			return context.loadModel(childItem);
		}
		return null;
	}
}
