package org.dimdev.dimdoors.client;

import java.util.List;
import java.util.stream.Collectors;
import java.util.stream.Stream;

import net.fabricmc.api.EnvType;
import net.fabricmc.api.Environment;
import net.minecraft.class_2960;
import net.minecraft.class_4587;
import net.minecraft.class_4597;
import net.minecraft.class_5617;
import net.minecraft.class_927;
import org.dimdev.dimdoors.entity.MonolithEntity;
import org.jetbrains.annotations.Nullable;

@Environment(EnvType.CLIENT)
public class MonolithRenderer extends class_927<MonolithEntity, MonolithModel> {
    public static final List<class_2960> MONOLITH_TEXTURES = Stream.of(
            new class_2960("dimdoors:textures/mob/monolith/monolith0.png"),
            new class_2960("dimdoors:textures/mob/monolith/monolith1.png"),
            new class_2960("dimdoors:textures/mob/monolith/monolith2.png"),
            new class_2960("dimdoors:textures/mob/monolith/monolith3.png"),
            new class_2960("dimdoors:textures/mob/monolith/monolith4.png"),
            new class_2960("dimdoors:textures/mob/monolith/monolith5.png"),
            new class_2960("dimdoors:textures/mob/monolith/monolith6.png"),
            new class_2960("dimdoors:textures/mob/monolith/monolith7.png"),
            new class_2960("dimdoors:textures/mob/monolith/monolith8.png"),
            new class_2960("dimdoors:textures/mob/monolith/monolith9.png"),
            new class_2960("dimdoors:textures/mob/monolith/monolith10.png"),
            new class_2960("dimdoors:textures/mob/monolith/monolith11.png"),
            new class_2960("dimdoors:textures/mob/monolith/monolith12.png"),
            new class_2960("dimdoors:textures/mob/monolith/monolith13.png"),
            new class_2960("dimdoors:textures/mob/monolith/monolith14.png"),
            new class_2960("dimdoors:textures/mob/monolith/monolith15.png"),
            new class_2960("dimdoors:textures/mob/monolith/monolith16.png"),
            new class_2960("dimdoors:textures/mob/monolith/monolith17.png"),
            new class_2960("dimdoors:textures/mob/monolith/monolith18.png")
	).collect(Collectors.toList());

    private static MonolithModel INSTANCE;

    public MonolithRenderer(class_5617.class_5618 ctx) {
        super(ctx, INSTANCE = new MonolithModel(ctx), 0);
    }

    public static MonolithModel getInstance() {
        return INSTANCE;
    }

    @Override
    public void render(MonolithEntity mobEntity, float f, float g, class_4587 matrixStack, class_4597 vertexConsumerProvider, int i) {
    	super.method_4072(mobEntity, f, g, matrixStack, vertexConsumerProvider, i);
    }

	@Override
	protected void scale(MonolithEntity entity, class_4587 matrices, float amount) {
		matrices.method_22905(entity.getScale(), entity.getScale(), entity.getScale());
	}

	@Override
    protected boolean hasLabel(MonolithEntity mobEntity) {
        return false;
    }

    @Override
    public class_2960 getTexture(MonolithEntity entity) {
        return MonolithRenderer.MONOLITH_TEXTURES.get(entity.getTextureState());
    }
}
