package org.dimdev.dimdoors.command;

import com.mojang.brigadier.Command;
import com.mojang.brigadier.CommandDispatcher;
import com.mojang.brigadier.arguments.FloatArgumentType;
import net.minecraft.class_1297;
import net.minecraft.class_1657;
import net.minecraft.class_2168;
import net.minecraft.class_2170;
import net.minecraft.class_2181;
import net.minecraft.class_2277;
import net.minecraft.class_2379;
import net.minecraft.class_243;
import net.minecraft.class_3218;
import net.minecraft.class_3222;
import org.dimdev.dimdoors.api.util.Location;
import org.dimdev.dimdoors.api.util.TeleportUtil;
import org.dimdev.dimdoors.api.util.math.MathUtil;
import org.dimdev.dimdoors.world.level.registry.DimensionalRegistry;

public class DimTeleportCommand {
    public static void register(CommandDispatcher<class_2168> dispatcher) {
        dispatcher.register(class_2170.method_9247("dimteleport")
				.requires(source -> source.method_9259(4))
                .then(class_2170
                        .method_9244("dimension", class_2181.method_9288())
                        .executes(ctx -> {
							class_3222 player = ctx.getSource().method_44023();
                            return teleport(player, class_2181.method_9289(ctx, "dimension"), player.method_19538(), MathUtil.entityEulerAngle(player));
                        })
                        .then(class_2170
                                .method_9244("coordinates", class_2277.method_9737())
                                .executes(ctx -> {
                                    class_3222 player = ctx.getSource().method_44023();
                                    return teleport(player, class_2181.method_9289(ctx, "dimension"), class_2277.method_9736(ctx, "coordinates"), MathUtil.entityEulerAngle(player));
                                })
								.then(class_2170
										.method_9244("yaw", FloatArgumentType.floatArg())
										.executes( ctx -> {
											class_3222 player = ctx.getSource().method_44023();
											return teleport(player, class_2181.method_9289(ctx, "dimension"), class_2277.method_9736(ctx, "coordinates"), new class_2379(player.method_36455(), FloatArgumentType.getFloat(ctx, "yaw"), 0));
										})
										.then(class_2170
												.method_9244("pitch", FloatArgumentType.floatArg())
												.executes( ctx -> {
													class_3222 player = ctx.getSource().method_44023();
													return teleport(player, class_2181.method_9289(ctx, "dimension"), class_2277.method_9736(ctx, "coordinates"), new class_2379(FloatArgumentType.getFloat(ctx, "pitch"), FloatArgumentType.getFloat(ctx, "yaw"), 0));
												})
										)
								)
                        )
                )
        );
    }

    private static int teleport(class_1297 entity, class_3218 dimension, class_243 pos, class_2379 angle) {
    	if(entity instanceof class_1657) {
			DimensionalRegistry.getRiftRegistry().setOverworldRift(entity.method_5667(), new Location((class_3218) entity.method_5770(), entity.method_24515()));
		}
		TeleportUtil.teleport(entity, dimension, pos, angle, entity.method_18798());
        return Command.SINGLE_SUCCESS;
    }
}
