package org.dimdev.dimdoors.command;

import com.mojang.brigadier.Command;
import com.mojang.brigadier.CommandDispatcher;
import com.mojang.brigadier.exceptions.CommandSyntaxException;
import net.fabricmc.loader.api.FabricLoader;
import net.minecraft.class_2168;
import net.minecraft.class_2588;
import net.minecraft.class_3222;
import net.minecraft.class_5250;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.dimdev.dimdoors.api.util.BlockPlacementType;
import org.dimdev.dimdoors.command.arguments.BlockPlacementTypeArgumentType;
import org.dimdev.dimdoors.command.arguments.PocketTemplateArgumentType;
import org.dimdev.dimdoors.pockets.PocketTemplate;
import org.dimdev.dimdoors.util.schematic.SchematicPlacer;

import java.util.HashMap;
import java.util.Map;
import java.util.UUID;

import static net.minecraft.class_2170.method_9244;
import static net.minecraft.class_2170.method_9247;

public class PocketCommand {
	private static final Logger LOGGER = LogManager.getLogger();

	// TODO: probably move somewhere else
	public static final Map<UUID, class_2168> logSetting = new HashMap<>();

	public static void register(CommandDispatcher<class_2168> dispatcher) {
		dispatcher.register(
				method_9247("pocket")
						.requires(source -> source.method_9259(2))
						.then(
								method_9247("schematic")
										.then(
												method_9247("place")
														.then(
																method_9244("pocket_template", new PocketTemplateArgumentType())
																		.executes(ctx -> place(ctx.getSource().method_44023(), PocketTemplateArgumentType.getValue(ctx, "pocket_template"), BlockPlacementType.SECTION_NO_UPDATE))
																		.then(
																				method_9244("placement_type", new BlockPlacementTypeArgumentType())
																						.executes(ctx -> place(ctx.getSource().method_44023(), PocketTemplateArgumentType.getValue(ctx, "pocket_template"), BlockPlacementTypeArgumentType.getBlockPlacementType(ctx, "placement_type")))
																		)
														)
										)
										.then(
												method_9247("load")
														.requires(source -> FabricLoader.getInstance().isModLoaded("worldedit"))
														.then(
																method_9244("pocket_template", new PocketTemplateArgumentType())
																		.executes(ctx -> load(ctx.getSource(), PocketTemplateArgumentType.getValue(ctx, "pocket_template")))
														)
										)
						)
						.then(
								method_9247("log")
										// TODO: make command toggle logging of pocket creation to console if used from console
										.then(method_9247("creation")
												.requires(commandSource -> commandSource.method_9228() instanceof class_3222)
												.executes(ctx -> {
													class_2168 commandSource = ctx.getSource();
													UUID playerUUID = commandSource.method_44023().method_5667();
													if (logSetting.containsKey(playerUUID)) {
														logSetting.remove(playerUUID);
														commandSource.method_9226(class_5250.method_43477(new class_2588("commands.pocket.log.creation.off")), false);
													} else {
														logSetting.put(playerUUID, commandSource);
														commandSource.method_9226(class_5250.method_43477(new class_2588("commands.pocket.log.creation.on")), false);
													}
													return Command.SINGLE_SUCCESS;
												})
										)

						)
		);
	}

	private static int load(class_2168 source, PocketTemplate template) throws CommandSyntaxException {
		try {
			return WorldeditHelper.load(source, template);
		} catch (NoClassDefFoundError e) {
			return 0;
		}
	}

	private static int place(class_3222 source, PocketTemplate template, BlockPlacementType blockPlacementType) throws CommandSyntaxException {
		SchematicPlacer.place(
				template.getSchematic(),
				source.method_14220(),
				source.method_24515(),
				blockPlacementType
		);

		String id = template.getId().toString();
		source.method_5671().method_9226(class_5250.method_43477(new class_2588("commands.pocket.placedSchem", id, "" + source.method_24515().method_10263() + ", " + source.method_24515().method_10264() + ", " + source.method_24515().method_10260(), source.field_6002.method_27983().method_29177().toString())), true);
		return Command.SINGLE_SUCCESS;
	}
}
