package org.dimdev.dimdoors.command;

import com.mojang.brigadier.Command;
import com.mojang.brigadier.exceptions.CommandSyntaxException;
import com.sk89q.jnbt.NBTInputStream;
import com.sk89q.worldedit.WorldEdit;
import com.sk89q.worldedit.extent.clipboard.Clipboard;
import com.sk89q.worldedit.extent.clipboard.io.SpongeSchematicReader;
import com.sk89q.worldedit.fabric.FabricAdapter;
import com.sk89q.worldedit.session.ClipboardHolder;
import org.dimdev.dimdoors.DimensionalDoorsInitializer;
import org.dimdev.dimdoors.pockets.PocketTemplate;
import org.dimdev.dimdoors.util.schematic.Schematic;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.util.concurrent.CompletableFuture;
import java.util.function.Consumer;
import net.minecraft.class_2168;
import net.minecraft.class_2487;
import net.minecraft.class_2507;
import net.minecraft.class_2588;
import net.minecraft.class_3222;
import net.minecraft.class_5250;

public class WorldeditHelper {
	static int load(class_2168 source, PocketTemplate template) throws CommandSyntaxException {
		class_3222 player = source.method_44023();
		boolean async = DimensionalDoorsInitializer.getConfig().getPocketsConfig().asyncWorldEditPocketLoading;
		Consumer<Runnable> taskAcceptor = async ? r -> source.method_9211().execute(r) : Runnable::run;
		Runnable task = () -> {
			class_2487 nbt = Schematic.toNbt(template.getSchematic());
			ByteArrayOutputStream stream = new ByteArrayOutputStream();
			try {
				class_2507.method_10634(nbt, stream);
			} catch (IOException e) {
				throw new RuntimeException(e); // Can't happen, the stream is a ByteArrayOutputStream
			}
			Clipboard clipboard;
			try {
				clipboard = new SpongeSchematicReader(new NBTInputStream(new ByteArrayInputStream(stream.toByteArray()))).read();
			} catch (IOException e) {
				throw new RuntimeException(e); // Can't happen, the stream is a ByteArrayInputStream
			}
			taskAcceptor.accept(() -> {
				WorldEdit.getInstance().getSessionManager().get(FabricAdapter.adaptPlayer(player)).setClipboard(new ClipboardHolder(clipboard));
				source.method_9226(class_5250.method_43477(new class_2588("commands.pocket.loadedSchem", template.getId())), true);
			});
		};
		if (async) {
			CompletableFuture.runAsync(task);
		} else {
			task.run();
		}
		return Command.SINGLE_SUCCESS;
	}

}
