package org.dimdev.dimdoors.entity;

import net.fabricmc.fabric.api.util.NbtType;
import net.minecraft.class_1282;
import net.minecraft.class_1299;
import net.minecraft.class_1308;
import net.minecraft.class_1313;
import net.minecraft.class_1333;
import net.minecraft.class_1657;
import net.minecraft.class_1936;
import net.minecraft.class_1937;
import net.minecraft.class_2338;
import net.minecraft.class_238;
import net.minecraft.class_2398;
import net.minecraft.class_243;
import net.minecraft.class_2487;
import net.minecraft.class_2940;
import net.minecraft.class_2943;
import net.minecraft.class_2945;
import net.minecraft.class_310;
import net.minecraft.class_3419;
import net.minecraft.class_3532;
import net.minecraft.class_3730;
import net.minecraft.class_4048;
import net.minecraft.class_4050;
import net.minecraft.class_5819;
import org.dimdev.dimdoors.DimensionalDoorsInitializer;
import org.dimdev.dimdoors.entity.ai.MonolithAggroGoal;
import org.dimdev.dimdoors.item.ModItems;
import org.dimdev.dimdoors.sound.ModSoundEvents;
import org.dimdev.dimdoors.world.ModDimensions;
import net.fabricmc.api.EnvType;
import net.fabricmc.api.Environment;

public class MonolithEntity extends class_1308 {
    public static final int MAX_AGGRO = 250;
    private static final int MAX_AGGRO_CAP = 100;
    private static final int MIN_AGGRO_CAP = 25;
    private static final int MAX_TEXTURE_STATE = 18;
    private static final int MAX_SOUND_COOLDOWN = 200;
    public static final int MAX_AGGRO_RANGE = 35;
    private static final class_2940<Integer> AGGRO = class_2945.method_12791(MonolithEntity.class, class_2943.field_13327);
    private static final class_2940<Float> SCALE = class_2945.method_12791(MonolithEntity.class, class_2943.field_13320);
	private static final class_2940<Float> PITCH = class_2945.method_12791(MonolithEntity.class, class_2943.field_13320);
    private static final float EYE_HEIGHT_PERCENTAGE = 0.55f;
    @Environment(EnvType.CLIENT)
    private static final class_5819 clientRandom = class_5819.method_43047();

    private int soundTime = 0;
    private final int aggroCap;

    MonolithEntity(class_1937 world) {
        this(ModEntityTypes.MONOLITH, world);
    }

    public MonolithEntity(class_1299<? extends MonolithEntity> type, class_1937 world) {
        super(ModEntityTypes.MONOLITH, world);
        this.field_5960 = true;
        this.aggroCap = class_3532.method_15395(this.method_6051(), MIN_AGGRO_CAP, MAX_AGGRO_CAP);
        this.method_5875(true);
        this.field_6206 = new class_1333(this) {
            @Override
            protected boolean method_20433() {
                return false;
            }
        };

        this.method_5684(true);
    }

    public boolean isDangerous() {
        return DimensionalDoorsInitializer.getConfig().getMonolithsConfig().monolithTeleportation && (ModDimensions.isLimboDimension(this.field_6002) || DimensionalDoorsInitializer.getConfig().getMonolithsConfig().dangerousLimboMonoliths);
    }

    @Override
    public boolean method_5643(class_1282 source, float amount) {
        if (source != class_1282.field_5855) {
            setAggro(MAX_AGGRO);
        }
        return false;
    }

    @Override
    protected int method_6130(int i) {
        return 10;
    }

    @Override
    protected int method_6064(int i) {
        return 10;
    }

//    @Override
//    public Box getCollisionBox() {
//        return null;
//    }
//
//    @Override
//    public Box getHardCollisionBox(Entity entity) {
//        return null;
//    }

    @Override
    public boolean method_17326() {
        return false;
    }

    @Override
    public boolean method_5810() {
        return false;
    }

    @Override
    protected void method_5693() {
        super.method_5693();
        // Add a short for the aggro level
        this.field_6011.method_12784(AGGRO, 0);
		this.field_6011.method_12784(SCALE, 1f);
		this.field_6011.method_12784(PITCH, 1f);
		this.method_18382();
    }

    @Override
    public boolean method_5805() {
        return false;
    }

    @Override
    public void method_5784(class_1313 movementType, class_243 vec3d) {
    }

    @Override
    protected void method_5958() {
        // Remove this Monolith if it's not in Limbo or in a pocket dungeon
        if (!(ModDimensions.isLimboDimension(this.field_6002) || ModDimensions.isPocketDimension(this.field_6002))) {
            this.method_5650(class_5529.field_26999);
            super.method_5958();
            return;
        }

        super.method_5958();

        // Check for players and update aggro levels even if there are no players in range
    }

    public void updateAggroLevel(class_1657 player, boolean visibility) {
        // If we're working on the server side, adjust aggro level
        // If we're working on the client side, retrieve aggro level from dataWatcher
        if (player == null) {
            return;
        }

        if ((player.method_31548().field_7548.get(0).method_7909() == ModItems.WORLD_THREAD_HELMET && player.method_31548().field_7548.get(1).method_7909() == ModItems.WORLD_THREAD_CHESTPLATE && player.method_31548().field_7548.get(2).method_7909() == ModItems.WORLD_THREAD_LEGGINGS && player.method_31548().field_7548.get(3).method_7909() == ModItems.WORLD_THREAD_BOOTS)) {
            return;
        }

        if (!this.field_6002.field_9236) {
            if (player.method_5739(this) > 70) {
                return;
            }

            int aggro = this.field_6011.method_12789(AGGRO);
            // Server side...
            // Rapidly increase the aggro level if this Monolith can see the player
            if (visibility) {
                if (ModDimensions.isLimboDimension(this.field_6002)) {
                    if (this.isDangerous()) {
                        aggro++;
                    } else {
                        aggro += 36;
                    }
                } else {
                    // Aggro increases faster outside of Limbo
                    aggro += 3;
                }
            } else {
                if (this.isDangerous()) {
                    if (aggro > this.aggroCap) {
                        // Decrease aggro over time
                        aggro--;
                    } else if (aggro < this.aggroCap) {
                        // Increase aggro if a player is within range and aggro < aggroCap
                        aggro++;
                    }
                } else {
                    aggro -= 3;
                }
            }
            // Clamp the aggro level
            int maxAggro = this.isDangerous() ? MAX_AGGRO : 180;
            aggro = (short) class_3532.method_15340(aggro, 0, maxAggro);
            this.field_6011.method_12778(AGGRO, aggro);
        }
    }

    @Environment(EnvType.CLIENT)
    public int getTextureState() {
        // Determine texture state from aggro progress
        return class_3532.method_15340(MAX_TEXTURE_STATE * this.field_6011.method_12789(AGGRO) / MAX_AGGRO, 0, MAX_TEXTURE_STATE);
    }

    /**
     * Plays sounds at different levels of aggro, using soundTime to prevent too many sounds at once.
     *
     * @param pos The position to play the sounds at
     */
    public void playSounds(class_243 pos) {
        float aggroPercent = this.getAggroProgress();
        float pitch = method_36455();
        if (this.soundTime <= 0) {
            this.method_5783(ModSoundEvents.MONK, 1F, pitch);
            this.soundTime = 100;
        }
        if (aggroPercent > 0.70 && this.soundTime < 100) {
            this.field_6002.method_8396(null, new class_2338(pos), ModSoundEvents.TEARING, class_3419.field_15251, 1F, (float) (1 + this.method_6051().method_43059()));
            this.soundTime = 100 + this.method_6051().method_43048(75);
        }
        if (aggroPercent > 0.80 && this.soundTime < MAX_SOUND_COOLDOWN) {
            this.field_6002.method_8396(null, new class_2338(pos), ModSoundEvents.TEARING, class_3419.field_15251, 7, 1);
            this.soundTime = 250;
        }
        this.soundTime--;
    }

    @Override
    public float method_18381(class_4050 entityPose) {
        return method_18377(entityPose).field_18068 * EYE_HEIGHT_PERCENTAGE;
    }

	@Override
	protected float method_18394(class_4050 pose, class_4048 dimensions) {
		return method_18377(pose).field_18068 * EYE_HEIGHT_PERCENTAGE;
	}

	@Environment(EnvType.CLIENT)
    public static void spawnParticles(int aggro) {
		class_1657 player = class_310.method_1551().field_1724;
		if (aggro < 120) {
			return;
		}
		int count = 10 * aggro / MAX_AGGRO;
		for (int i = 1; i < count; ++i) {
			//noinspection ConstantConditions
			player.field_6002.method_8406(class_2398.field_11214, player.method_23317() + (clientRandom.method_43058() - 0.5D) * 3.0,
					player.method_23318() + clientRandom.method_43058() * player.method_17682() - 0.75D,
					player.method_23321() + (clientRandom.method_43058() - 0.5D) * player.method_17681(),
					(clientRandom.method_43058() - 0.5D) * 2.0D, -clientRandom.method_43058(),
					(clientRandom.method_43058() - 0.5D) * 2.0D);
		}
	}

    public float getAggroProgress() {
        return ((float) getAggro()) / MAX_AGGRO;
    }

    @Override
    protected void method_5959() {
        super.method_5959();
        this.field_6201.method_6277(0, new MonolithAggroGoal(this, MAX_AGGRO_RANGE));
    }

    public void facePlayer(class_1657 player) {
        this.field_6206.method_6226(player, 1.0f, 1.0f);
    }

    @Override
    public void method_5652(class_2487 nbt) {
        super.method_5652(nbt);
        nbt.method_10569("Aggro", getAggro());
        nbt.method_10548("scale", getScale());
        nbt.method_10548("pitch", method_36455());
    }

    @Override
    public void method_5749(class_2487 nbt) {
        super.method_5749(nbt);
        setAggro(nbt.method_10550("Aggro"));
        if (nbt.method_10573("scale", NbtType.FLOAT)) {
        	setScale(nbt.method_10583("scale"));
		}
        if (nbt.method_10573("pitch", NbtType.FLOAT)) {
			method_36457(nbt.method_10583("pitch"));
		}
    }

	public int getAggro() {
        return this.field_6011.method_12789(AGGRO);
    }

    public void setAggro(int aggro) {
        this.field_6011.method_12778(AGGRO, aggro);
    }

	@Override
	public float method_17825() {
		return getScale();
	}

	public float getScale() {
    	return this.field_6011.method_12789(SCALE);
	}

    public void setScale(float scale) {
    	this.field_6011.method_12778(SCALE, scale);
    	method_18382();
	}

	public float method_36455() {
    	return this.field_6011.method_12789(PITCH);
	}

	public void method_36457(float pitch) {
    	this.field_6011.method_12778(PITCH, pitch);
	}

	@Override
	public class_238 method_24833(class_4050 pose) {
    	float scale = getScale();
		return super.method_24833(pose).method_1012(scale, scale, scale);
	}

	@Override
	public void method_5674(class_2940<?> data) {
		if (SCALE.equals(data)) {
			this.method_18382();
		}

		super.method_5674(data);
	}

	@Override
    public boolean method_5979(class_1936 world, class_3730 spawnReason) {
        if (spawnReason == class_3730.field_16472) {
            return super.method_5979(world, spawnReason);
        }
        if (spawnReason == class_3730.field_16459) {
            return this.method_6051().method_43048(32) == 2;
        }
        return false;
    }
}
