package org.dimdev.dimdoors.entity.ai;

import org.dimdev.dimdoors.DimensionalDoorsInitializer;
import org.dimdev.dimdoors.entity.MonolithEntity;
import org.dimdev.dimdoors.entity.stat.ModStats;
import org.dimdev.dimdoors.item.ModItems;
import org.dimdev.dimdoors.network.ServerPacketHandler;
import org.dimdev.dimdoors.network.packet.s2c.MonolithAggroParticlesPacket;
import org.dimdev.dimdoors.network.packet.s2c.MonolithTeleportParticlesPacket;
import org.dimdev.dimdoors.sound.ModSoundEvents;

import java.util.EnumSet;
import net.minecraft.class_1301;
import net.minecraft.class_1352;
import net.minecraft.class_1657;
import net.minecraft.class_2338;
import net.minecraft.class_3222;
import net.minecraft.class_3419;
import net.minecraft.class_4051;
import net.minecraft.class_5819;

import static org.dimdev.dimdoors.entity.MonolithEntity.MAX_AGGRO;

public class MonolithAggroGoal extends class_1352 {
	protected final MonolithEntity mob;
    protected class_1657 target;
    protected final float range;
    protected final class_4051 targetPredicate;

    public MonolithAggroGoal(MonolithEntity mobEntity, float f) {
        this.mob = mobEntity;
        this.range = f;
        this.method_6265(EnumSet.of(class_1352.class_4134.field_18406));
        this.targetPredicate = (class_4051.method_36625()).method_18418(this.range).method_18420(class_1301.field_6156::test);
    }

    private class_1657 getTarget() {
        class_1657 playerEntity = this.mob.field_6002.method_18463(this.targetPredicate, this.mob, this.mob.method_23317(), this.mob.method_23320(), this.mob.method_23321());
        return playerEntity != null && this.mob.method_6057(playerEntity) && playerEntity.method_5739(this.mob) < 50 ? playerEntity : null;
    }

    public boolean method_6264() {
        return (this.target = this.getTarget()) != null && this.target.method_5739(this.mob) <= 50;
    }

    public boolean method_6266() {
        return (this.target = this.getTarget()) != null && this.target.method_5739(this.mob) <= 50;
    }

    public void method_6269() {
    }

    public void method_6270() {
        this.target = null;
        this.mob.setAggro(0);
    }

    public void method_6268() {
        if (this.target != null && this.target.method_5739(this.mob) > 70) {
            this.method_6270();
            return;
        }

        if (this.target != null && (this.target.method_31548().field_7548.get(0).method_7909() == ModItems.WORLD_THREAD_HELMET && this.target.method_31548().field_7548.get(1).method_7909() == ModItems.WORLD_THREAD_CHESTPLATE && this.target.method_31548().field_7548.get(2).method_7909() == ModItems.WORLD_THREAD_LEGGINGS && this.target.method_31548().field_7548.get(3).method_7909() == ModItems.WORLD_THREAD_BOOTS)) {
            class_5819 random = class_5819.method_43047();
            int i = random.method_43048(64);
            if (this.target instanceof class_3222) {
                if (i < 4) {
                    this.target.method_31548().field_7548.get(0).method_7970(i, random, (class_3222) this.target);
                    this.target.method_31548().field_7548.get(1).method_7970(i, random, (class_3222) this.target);
                    this.target.method_31548().field_7548.get(2).method_7970(i, random, (class_3222) this.target);
                    this.target.method_31548().field_7548.get(3).method_7970(i, random, (class_3222) this.target);
                }
            }
            return;
        }

        boolean visibility = this.target != null;
        this.mob.updateAggroLevel(this.target, visibility);

        // Change orientation and face a player if one is in range
        if (this.target != null) {
            this.mob.facePlayer(this.target);
            if (this.mob.isDangerous()) {
                // Play sounds on the server side, if the player isn't in Limbo.
                // Limbo is excluded to avoid drowning out its background music.
                // Also, since it's a large open area with many Monoliths, some
                // of the sounds that would usually play for a moment would
                // keep playing constantly and would get very annoying.
                this.mob.playSounds(this.target.method_19538());
				ServerPacketHandler.get((class_3222) this.target).sendPacket(new MonolithAggroParticlesPacket(this.mob.getAggro()));
            }

            // Teleport the target player if various conditions are met
            if (this.mob.getAggro() >= MAX_AGGRO && DimensionalDoorsInitializer.getConfig().getMonolithsConfig().monolithTeleportation && !this.target.method_7337() && this.mob.isDangerous()) {
                this.mob.setAggro(0);
				this.target.method_20620(this.target.method_23317(), this.target.method_23318() + 256, this.target.method_23321());
                this.target.field_6002.method_8396(null, new class_2338(this.target.method_19538()), ModSoundEvents.CRACK, class_3419.field_15251, 13, 1);
                this.target.method_7281(ModStats.TIMES_TELEPORTED_BY_MONOLITH);
                ServerPacketHandler.get((class_3222) this.target).sendPacket(new MonolithTeleportParticlesPacket());
			}
        }
    }
}
