package org.dimdev.dimdoors.fluid;

import java.util.function.Function;

import net.fabricmc.api.EnvType;
import net.fabricmc.api.Environment;
import net.fabricmc.fabric.api.client.render.fluid.v1.FluidRenderHandler;
import net.fabricmc.fabric.api.client.render.fluid.v1.FluidRenderHandlerRegistry;
import net.fabricmc.fabric.api.event.client.ClientSpriteRegistryCallback;
import net.fabricmc.fabric.api.resource.ResourceManagerHelper;
import net.fabricmc.fabric.api.resource.SimpleSynchronousResourceReloadListener;
import net.minecraft.class_1058;
import net.minecraft.class_1723;
import net.minecraft.class_1920;
import net.minecraft.class_2338;
import net.minecraft.class_2378;
import net.minecraft.class_2960;
import net.minecraft.class_310;
import net.minecraft.class_3264;
import net.minecraft.class_3300;
import net.minecraft.class_3609;
import net.minecraft.class_3610;
import net.minecraft.class_3611;

public class ModFluids {
	public static final class_3609 ETERNAL_FLUID = register("dimdoors:eternal_fluid", new EternalFluid.Still());
	public static final class_3609 FLOWING_ETERNAL_FLUID = register("dimdoors:flowing_eternal_fluid", new EternalFluid.Flowing());

	private static <T extends class_3611> T register(String string, T fluid) {
		return class_2378.method_10226(class_2378.field_11154, string, fluid);
	}

	public static void init() {
	}

	public static void initClient() {
		setupFluidRendering(ModFluids.ETERNAL_FLUID, ModFluids.FLOWING_ETERNAL_FLUID, new class_2960("dimdoors:eternal_fluid"));
	}

	@Environment(EnvType.CLIENT)
	private static void setupFluidRendering(class_3611 still, class_3611 flowing, final class_2960 textureFluidId) {
		final class_2960 stillSpriteId = new class_2960(textureFluidId.method_12836(), "block/" + textureFluidId.method_12832() + "_still");
		final class_2960 flowingSpriteId = new class_2960(textureFluidId.method_12836(), "block/" + textureFluidId.method_12832() + "_flow");

		// If they're not already present, add the sprites to the block atlas
		ClientSpriteRegistryCallback.event(class_1723.field_21668).register((atlasTexture, registry) -> {
			registry.register(stillSpriteId);
			registry.register(flowingSpriteId);
		});

		final class_2960 fluidId = class_2378.field_11154.method_10221(still);
		final class_2960 listenerId = new class_2960(fluidId.method_12836(), fluidId.method_12832() + "_reload_listener");

		final class_1058[] fluidSprites = {null, null};

		ResourceManagerHelper.get(class_3264.field_14188).registerReloadListener(new SimpleSynchronousResourceReloadListener() {
			@Override
			public class_2960 getFabricId() {
				return listenerId;
			}

			/**
			 * Get the sprites from the block atlas when resources are reloaded
			 */
			@Override
			public void method_14491(class_3300 resourceManager) {
				final Function<class_2960, class_1058> atlas = class_310.method_1551().method_1549(class_1723.field_21668);
				fluidSprites[0] = atlas.apply(stillSpriteId);
				fluidSprites[1] = atlas.apply(flowingSpriteId);
			}
		});

		// The FluidRenderer gets the sprites and color from a FluidRenderHandler during rendering
		final FluidRenderHandler renderHandler = new FluidRenderHandler() {
			@Override
			public class_1058[] getFluidSprites(class_1920 view, class_2338 pos, class_3610 state) {
				return fluidSprites;
			}

			@Override
			public int getFluidColor(class_1920 view, class_2338 pos, class_3610 state) {
				return 16777215;
			}
		};

		FluidRenderHandlerRegistry.INSTANCE.register(still, renderHandler);
		FluidRenderHandlerRegistry.INSTANCE.register(flowing, renderHandler);
	}
}
