package org.dimdev.dimdoors.item;

import java.util.function.Consumer;
import net.minecraft.class_1269;
import net.minecraft.class_1747;
import net.minecraft.class_1750;
import net.minecraft.class_1937;
import net.minecraft.class_2248;
import net.minecraft.class_2338;
import net.minecraft.class_2680;
import org.dimdev.dimdoors.block.RiftProvider;
import org.dimdev.dimdoors.block.entity.EntranceRiftBlockEntity;

public class DimensionalTrapdoorItem extends class_1747 {
	private final Consumer<? super EntranceRiftBlockEntity> setupFunction;

	public DimensionalTrapdoorItem(class_2248 block, class_1793 settings, Consumer<? super EntranceRiftBlockEntity> setupFunction) {
		super(block, settings);
		this.setupFunction = setupFunction;
	}

	@Override
	public class_1269 method_7712(class_1750 context) {
		class_1937 world = context.method_8045();
		class_2338 pos = context.method_8037();

		if (world.field_9236) {
			return super.method_7712(context);
		}

		boolean replaceable = world.method_8320(pos).method_26166(context); // Check this before calling super, since that changes the block
		class_1269 result = super.method_7712(context);

		if (result == class_1269.field_5812) {
			if (!replaceable) {
				pos = pos.method_10093(context.method_7715());
			}

			class_2680 state = world.method_8320(pos);
			// Get the rift entity (not hard coded, works with any door size)
			EntranceRiftBlockEntity entranceRift = ((RiftProvider<EntranceRiftBlockEntity>) state.method_26204()).getRift(world, pos, state);

			// Configure the rift to its default functionality
			this.setupRift(entranceRift);

			// Register the rift in the registry
			entranceRift.method_5431();
			entranceRift.register();
		}

		return result;
	}

	protected void setupRift(EntranceRiftBlockEntity entranceRift) {
		this.setupFunction.accept(entranceRift);
	}
}
