package org.dimdev.dimdoors.item;

import net.fabricmc.api.EnvType;
import net.fabricmc.api.Environment;
import net.minecraft.class_1268;
import net.minecraft.class_1269;
import net.minecraft.class_1271;
import net.minecraft.class_1309;
import net.minecraft.class_1657;
import net.minecraft.class_1799;
import net.minecraft.class_1829;
import net.minecraft.class_1834;
import net.minecraft.class_1836;
import net.minecraft.class_1937;
import net.minecraft.class_2338;
import net.minecraft.class_239;
import net.minecraft.class_243;
import net.minecraft.class_2561;
import net.minecraft.class_2588;
import net.minecraft.class_3965;
import net.minecraft.class_5250;
import org.dimdev.dimdoors.DimensionalDoorsInitializer;
import org.dimdev.dimdoors.block.DimensionalPortalBlock;
import org.dimdev.dimdoors.block.ModBlocks;
import org.dimdev.dimdoors.block.entity.EntranceRiftBlockEntity;
import org.dimdev.dimdoors.block.entity.RiftBlockEntity;
import org.dimdev.dimdoors.client.ToolTipHelper;

import java.util.List;
import java.util.Objects;

public class RiftBladeItem extends class_1829 {
	public static final String ID = "rift_blade";

	public RiftBladeItem(class_1793 settings) {
		super(class_1834.field_8923, 3, -2.4F, settings);
	}

	@Environment(EnvType.CLIENT)
	@Override
	public void method_7851(class_1799 itemStack, class_1937 world, List<class_2561> list, class_1836 tooltipContext) {
		ToolTipHelper.processTranslation(list, this.method_7876() + ".info");
	}

	@Override
	public boolean method_7886(class_1799 itemStack) {
		return true;
	}

	@Override
	public boolean method_7878(class_1799 item, class_1799 repairingItem) {
		return Objects.equals(ModItems.STABLE_FABRIC, repairingItem.method_7909());
	}

	@Override
	public class_1271<class_1799> method_7836(class_1937 world, class_1657 player, class_1268 hand) {
		class_1799 stack = player.method_5998(hand);
		class_239 hit = RaycastHelper.raycast(player, 16, 0.0F, class_1309.class::isInstance);

		if (hit == null) {
			hit = RaycastHelper.raycast(player, 16, 1.0F, class_1309.class::isInstance);
		}

		if (hit == null) {
			hit = player.method_5745(16, 1.0F, false); //TODO: make the range of the Rift Blade configurable
		}

		if (hit == null) {
			hit = player.method_5745(16, 0, false);
		}

		if (world.field_9236) {
			if (RaycastHelper.hitsLivingEntity(hit) || RaycastHelper.hitsRift(hit, world)) {
				return new class_1271<>(class_1269.field_5812, stack);
			} else {
				player.method_7353(class_5250.method_43477(new class_2588(this.method_7876() + ".rift_miss")), true);
				RiftBlockEntity.showRiftCoreUntil = System.currentTimeMillis() + DimensionalDoorsInitializer.getConfig().getGraphicsConfig().highlightRiftCoreFor;
				return new class_1271<>(class_1269.field_5814, stack);
			}
		}

		if (RaycastHelper.hitsLivingEntity(hit)) {
			double damageMultiplier = (double) stack.method_7919() / (double) stack.method_7936();
			// TODO: gaussian, instead or random
			double offsetDistance = Math.random() * damageMultiplier * 7 + 2; //TODO: make these offset distances configurable
			double offsetRotationYaw = (Math.random() - 0.5) * damageMultiplier * 360;

			class_243 playerVec = player.method_19538();
			class_243 entityVec = hit.method_17784();
			class_243 offsetDirection = playerVec.method_1020(entityVec).method_1029();
			offsetDirection = offsetDirection.method_1024((float) (offsetRotationYaw * Math.PI) / 180);

			class_2338 teleportPosition = new class_2338(entityVec.method_1019(offsetDirection.method_1021(offsetDistance)));
			while (world.method_8320(teleportPosition).method_26207().method_15801())
				teleportPosition = teleportPosition.method_10084();
			player.method_20620(teleportPosition.method_10263(), teleportPosition.method_10264(), teleportPosition.method_10260());
			player.method_36456((float) (Math.random() * 2 * Math.PI));

			stack.method_7956(1, player, a -> a.method_20236(hand));
			return new class_1271<>(class_1269.field_5812, stack);
		} else if (RaycastHelper.hitsDetachedRift(hit, world)) {
			class_3965 blockHitResult = (class_3965) hit;
			class_2338 pos = blockHitResult.method_17777();
			RiftBlockEntity rift = (RiftBlockEntity) world.method_8321(blockHitResult.method_17777());

			world.method_8501(pos, ModBlocks.DIMENSIONAL_PORTAL.method_9564().method_11657(DimensionalPortalBlock.FACING, blockHitResult.method_17780()));
			((EntranceRiftBlockEntity) world.method_8321(pos)).setData(rift.getData());

			stack.method_7956(1, player, a -> a.method_20236(hand));
			return new class_1271<>(class_1269.field_5812, stack);
		}
		return new class_1271<>(class_1269.field_5814, stack);
	}
}
