package org.dimdev.dimdoors.item;

import net.fabricmc.api.Environment;
import net.minecraft.class_1074;
import net.minecraft.class_1268;
import net.minecraft.class_1271;
import net.minecraft.class_1657;
import net.minecraft.class_1792;
import net.minecraft.class_1799;
import net.minecraft.class_1836;
import net.minecraft.class_1937;
import net.minecraft.class_2338;
import net.minecraft.class_2350;
import net.minecraft.class_239;
import net.minecraft.class_2561;
import net.minecraft.class_2586;
import net.minecraft.class_2588;
import net.minecraft.class_3222;
import net.minecraft.class_3965;
import net.minecraft.class_5250;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.dimdev.dimdoors.api.item.ExtendedItem;
import org.dimdev.dimdoors.api.util.EntityUtils;
import org.dimdev.dimdoors.block.entity.RiftBlockEntity;
import org.dimdev.dimdoors.item.component.CounterComponent;
import org.dimdev.dimdoors.network.ServerPacketHandler;
import org.dimdev.dimdoors.rift.targets.IdMarker;

import java.util.List;

import static net.fabricmc.api.EnvType.CLIENT;

public class RiftConfigurationToolItem extends class_1792 implements ExtendedItem {
	private static final Logger LOGGER = LogManager.getLogger();

	public static final String ID = "rift_configuration_tool";

	RiftConfigurationToolItem() {
		super(new class_1792.class_1793().method_7892(ModItems.DIMENSIONAL_DOORS).method_7889(1).method_7895(16));
	}

	@Override
	public class_1271<class_1799> method_7836(class_1937 world, class_1657 player, class_1268 hand) {
		class_1799 stack = player.method_5998(hand);
		class_239 hit = player.method_5745(RaycastHelper.REACH_DISTANCE, 0, false);

		if (world.field_9236) {
			return class_1271.method_22431(stack);
		} else {
			CounterComponent counter = CounterComponent.get(stack);

			if (RaycastHelper.hitsRift(hit, world)) {
				RiftBlockEntity rift = (RiftBlockEntity) world.method_8321(((class_3965) hit).method_17777());

				if (rift.getDestination() instanceof IdMarker && ((IdMarker) rift.getDestination()).getId() >= 0) {
					EntityUtils.chat(player, class_2561.method_30163("Id: " + ((IdMarker) rift.getDestination()).getId()));
				} else {
					int id = counter.increment();

					ServerPacketHandler.get((class_3222) player).sync(stack, hand);

					EntityUtils.chat(player, class_2561.method_30163("Rift stripped of data and set to target id: " + id));

					rift.setDestination(new IdMarker(id));
				}

				return class_1271.method_22427(stack);
			} else {
				EntityUtils.chat(player, class_2561.method_30163("Current Count: " + counter.count()));
			}
		}

		return class_1271.method_22427(stack);
	}

	@Override
	public class_1271<Boolean> onAttackBlock(class_1937 world, class_1657 player, class_1268 hand, class_2338 pos, class_2350 direction) {
		if (world.field_9236) {
			if (player.method_5715()) {
				if (CounterComponent.get(player.method_5998(hand)).count() != 0 || world.method_8321(pos) instanceof RiftBlockEntity) {
					return class_1271.method_22427(true);
				}
				return class_1271.method_22431(false);
			}
		} else {
			class_1799 stack = player.method_5998(hand);
			if (player.method_5715()) {
				class_2586 blockEntity = world.method_8321(pos);
				if (blockEntity instanceof RiftBlockEntity) {
					RiftBlockEntity rift = (RiftBlockEntity) blockEntity;
					if (!(rift.getDestination() instanceof IdMarker) || ((IdMarker) rift.getDestination()).getId() != -1) {
						rift.setDestination(new IdMarker(-1));
						EntityUtils.chat(player, class_2561.method_30163("Rift stripped of data and set to invalid id: -1"));
						return class_1271.method_22427(false);
					}
				} else if (CounterComponent.get(stack).count() != 0) {
					CounterComponent.get(stack).reset();

					ServerPacketHandler.get((class_3222) player).sync(stack, hand);

					EntityUtils.chat(player, class_2561.method_30163("Counter has been reset."));
					return class_1271.method_22427(false);
				}
			}
		}
		return class_1271.method_22430(false);
	}

	@Override
	@Environment(CLIENT)
	public void method_7851(class_1799 itemStack, class_1937 world, List<class_2561> list, class_1836 tooltipContext) {
		if (class_1074.method_4663(this.method_7876() + ".info")) {
			list.add(class_5250.method_43477(new class_2588(this.method_7876() + ".info")));
		}
	}
}
