package org.dimdev.dimdoors.item;

import net.fabricmc.fabric.api.util.NbtType;
import net.minecraft.class_1269;
import net.minecraft.class_1657;
import net.minecraft.class_1761;
import net.minecraft.class_1792;
import net.minecraft.class_1799;
import net.minecraft.class_1836;
import net.minecraft.class_1838;
import net.minecraft.class_1937;
import net.minecraft.class_2371;
import net.minecraft.class_2495;
import net.minecraft.class_2561;
import net.minecraft.class_2588;
import net.minecraft.class_2680;
import net.minecraft.class_3222;
import net.minecraft.class_4844;
import net.minecraft.class_5250;
import org.dimdev.dimdoors.api.util.EntityUtils;
import org.dimdev.dimdoors.api.util.Location;
import org.dimdev.dimdoors.block.RiftProvider;
import org.dimdev.dimdoors.block.entity.EntranceRiftBlockEntity;
import org.dimdev.dimdoors.block.entity.RiftBlockEntity;
import org.dimdev.dimdoors.mixin.accessor.ListTagAccessor;
import org.dimdev.dimdoors.network.ServerPacketHandler;
import org.dimdev.dimdoors.rift.registry.Rift;
import org.dimdev.dimdoors.world.level.registry.DimensionalRegistry;
import org.jetbrains.annotations.Nullable;

import java.util.ArrayList;
import java.util.List;
import java.util.UUID;
import java.util.stream.Collectors;

public class RiftKeyItem extends class_1792 {
	public RiftKeyItem(class_1793 settings) {
		super(settings);
	}

	@Override
	public void method_7851(class_1799 stack, @Nullable class_1937 world, List<class_2561> tooltip, class_1836 context) {
		if (isEmpty(stack)) {
			tooltip.add(class_5250.method_43477(new class_2588("item.dimdoors.rift_key.no_links")));
		} else if (context.method_8035()) {
			for (UUID id : getIds(stack)) {
				tooltip.add(class_2561.method_30163(" " + id.toString()));
			}
		}
		super.method_7851(stack, world, tooltip, context);
	}

	@Override
	public boolean method_7886(class_1799 stack) {
		return !isEmpty(stack);
	}

	@Override
	public boolean method_7887() {
		return super.method_7887();
	}

	@Override
	public int method_7881(class_1799 stack) {
		return 30;
	}

	@Override
	public void method_7843(class_1799 stack, class_1937 world, class_1657 player) {
		stack.method_7980(this.method_7854().method_7969());
	}

	@Override
	public class_1799 method_7854() {
		class_1799 stack = super.method_7854();
		stack.method_7959("Ids", ListTagAccessor.createListTag(new ArrayList<>(), (byte) NbtType.INT_ARRAY));
		return stack;
	}

	@Override
	public class_1269 method_7884(class_1838 context) {
		if (context.method_8045().field_9236) {
			return class_1269.field_21466;
		}
		class_1657 player = context.method_8036();
		class_2680 state = context.method_8045().method_8320(context.method_8037());
		if (player != null && state.method_26204() instanceof RiftProvider && player.method_21751()) {
			RiftBlockEntity riftBlockEntity = ((RiftProvider<?>) state.method_26204()).getRift(context.method_8045(), context.method_8037(), state);
			if (riftBlockEntity.isDetached()) {
				return super.method_7884(context);
			}
			EntranceRiftBlockEntity entranceRiftBlockEntity = ((EntranceRiftBlockEntity) riftBlockEntity);
			Rift rift = DimensionalRegistry.getRiftRegistry().getRift(new Location(entranceRiftBlockEntity.method_10997().method_27983(), entranceRiftBlockEntity.method_11016()));
			if (entranceRiftBlockEntity.isLocked()) {
				if (tryRemove(context.method_8041(), rift.getId())) {
					entranceRiftBlockEntity.setLocked(false);
					entranceRiftBlockEntity.method_5431();
					EntityUtils.chat(player, class_5250.method_43477(new class_2588("rifts.unlocked")));
					ServerPacketHandler.get((class_3222) player).sync(context.method_8041(), context.method_20287());
					return class_1269.field_5812;
				} else {
					EntityUtils.chat(player, class_5250.method_43477(new class_2588("rifts.cantUnlock")));
				}
			} else {
				entranceRiftBlockEntity.setLocked(true);
				add(context.method_8041(), rift.getId());
				entranceRiftBlockEntity.method_5431();
				EntityUtils.chat(player, class_5250.method_43477(new class_2588("rifts.locked")));
				ServerPacketHandler.get((class_3222) player).sync(context.method_8041(), context.method_20287());
 				return class_1269.field_5812;
			}
		}
		return super.method_7884(context);
	}

	public static boolean tryRemove(class_1799 stack, UUID id) {
		class_2495 arrayTag = new class_2495(class_4844.method_26275(id));
		return stack.method_7969().method_10554("Ids", NbtType.INT_ARRAY).remove(arrayTag);
	}

	public static void add(class_1799 stack, UUID id) {
		if (!has(stack, id)) {
			stack.method_7948().method_10554("Ids", NbtType.INT_ARRAY).add(new class_2495(class_4844.method_26275(id)));
		}
	}

	public static boolean has(class_1799 stack, UUID id) {
		return stack.method_7948().method_10554("Ids", NbtType.INT_ARRAY).contains(new class_2495(class_4844.method_26275(id)));
	}

	public static boolean isEmpty(class_1799 stack) {
		return stack.method_7948().method_10554("Ids", NbtType.INT_ARRAY).isEmpty();
	}

	public static List<UUID> getIds(class_1799 stack) {
		return stack.method_7948()
				.method_10554("Ids", NbtType.INT_ARRAY)
				.stream()
				.map(class_2495.class::cast)
				.map(class_2495::method_10588)
				.map(class_4844::method_26276)
				.collect(Collectors.toList());
	}

	@Override
	public void method_7850(class_1761 group, class_2371<class_1799> stacks) {
		if (this.method_7877(group)) {
			stacks.add(this.method_7854());
		}
	}
}
