package org.dimdev.dimdoors.item;

import net.fabricmc.api.EnvType;
import net.fabricmc.api.Environment;
import net.minecraft.class_1268;
import net.minecraft.class_1269;
import net.minecraft.class_1271;
import net.minecraft.class_1657;
import net.minecraft.class_1792;
import net.minecraft.class_1799;
import net.minecraft.class_1836;
import net.minecraft.class_1937;
import net.minecraft.class_239;
import net.minecraft.class_2561;
import net.minecraft.class_2588;
import net.minecraft.class_3419;
import net.minecraft.class_3965;
import net.minecraft.class_5250;
import org.dimdev.dimdoors.DimensionalDoorsInitializer;
import org.dimdev.dimdoors.block.entity.DetachedRiftBlockEntity;
import org.dimdev.dimdoors.block.entity.RiftBlockEntity;
import org.dimdev.dimdoors.client.ToolTipHelper;
import org.dimdev.dimdoors.sound.ModSoundEvents;

import java.util.List;
import java.util.Objects;

public class RiftRemoverItem extends class_1792 {
	public static final String ID = "rift_remover";

	public RiftRemoverItem(class_1793 settings) {
		super(settings);
	}

	@Environment(EnvType.CLIENT)
	@Override
	public void method_7851(class_1799 itemStack, class_1937 world, List<class_2561> list, class_1836 tooltipContext) {
		ToolTipHelper.processTranslation(list, this.method_7876() + ".info");
	}

	@Override
	public class_1271<class_1799> method_7836(class_1937 world, class_1657 player, class_1268 hand) {
		class_1799 stack = player.method_5998(hand);
		class_239 hit = player.method_5745(RaycastHelper.REACH_DISTANCE, 0, false);

		if (world.field_9236) {
			if (!RaycastHelper.hitsDetachedRift(hit, world)) {
				player.method_7353(class_5250.method_43477(new class_2588("tools.rift_miss")), true);
				RiftBlockEntity.showRiftCoreUntil = System.currentTimeMillis() + DimensionalDoorsInitializer.getConfig().getGraphicsConfig().highlightRiftCoreFor;
			}
			return new class_1271<>(class_1269.field_5814, stack);
		}

		if (RaycastHelper.hitsDetachedRift(hit, world)) {
			// casting to BlockHitResult is mostly safe since RaycastHelper#hitsDetachedRift already checks hit type
			DetachedRiftBlockEntity rift = (DetachedRiftBlockEntity) world.method_8321(((class_3965) hit).method_17777());
			if (!Objects.requireNonNull(rift).closing) {
				rift.setClosing(true);
				world.method_8396(null, player.method_24515(), ModSoundEvents.RIFT_CLOSE, class_3419.field_15245, 0.6f, 1);
				stack.method_7956(10, player, a -> a.method_20236(hand));
				player.method_7353(class_5250.method_43477(new class_2588(this.method_7876() + ".closing")), true);
				return new class_1271<>(class_1269.field_5812, stack);
			} else {
				player.method_7353(class_5250.method_43477(new class_2588(this.method_7876() + ".already_closing")), true);
			}
		}
		return new class_1271<>(class_1269.field_5814, stack);
	}
}
