package org.dimdev.dimdoors.item;

import net.minecraft.class_1268;
import net.minecraft.class_1269;
import net.minecraft.class_1657;
import net.minecraft.class_1750;
import net.minecraft.class_1792;
import net.minecraft.class_1799;
import net.minecraft.class_1838;
import net.minecraft.class_1937;
import net.minecraft.class_2338;
import net.minecraft.class_2350;
import net.minecraft.class_2487;
import net.minecraft.class_2588;
import net.minecraft.class_3218;
import net.minecraft.class_3419;
import net.minecraft.class_5250;
import org.dimdev.dimdoors.DimensionalDoorsInitializer;
import org.dimdev.dimdoors.api.util.Location;
import org.dimdev.dimdoors.api.util.RotatedLocation;
import org.dimdev.dimdoors.block.ModBlocks;
import org.dimdev.dimdoors.block.entity.DetachedRiftBlockEntity;
import org.dimdev.dimdoors.rift.targets.RiftReference;
import org.dimdev.dimdoors.sound.ModSoundEvents;

public class StabilizedRiftSignatureItem extends class_1792 { // TODO: common superclass with rift signature
	public static final String ID = "stabilized_rift_signature";

	public StabilizedRiftSignatureItem(class_1793 settings) {
		super(settings);
	}

	@Override
	public boolean method_7886(class_1799 stack) {
		return stack.method_7969() != null && stack.method_7969().method_10545("destination");
	}

	@Override
	public class_1269 method_7884(class_1838 itemUsageContext) {
		class_1657 player = itemUsageContext.method_8036();
		class_1937 world = itemUsageContext.method_8045();
		class_2338 pos = itemUsageContext.method_8037();
		class_1268 hand = itemUsageContext.method_20287();
		class_2350 side = itemUsageContext.method_8038();

		class_1750 itemPlacementContext = new class_1750(itemUsageContext);

		class_1799 stack = player.method_5998(hand);
		pos = world.method_8320(pos).method_26204().method_9616(world.method_8320(pos), new class_1750(itemUsageContext)) ? pos : pos.method_10093(side);
		// Fail if the player can't place a block there
		if (!player.method_7343(pos, side.method_10153(), stack)) {
			return class_1269.field_5814;
		}

		if (world.field_9236) {
			return class_1269.field_5812;
		}

		RotatedLocation target = getTarget(stack);

		if (target == null) {
			// The link signature has not been used. Store its current target as the first location.
			setSource(stack, new RotatedLocation(world.method_27983(), pos, player.method_36454(), 0));
			player.method_7353(class_5250.method_43477(new class_2588(this.method_7876() + ".stored")), true);
			world.method_8396(null, player.method_24515(), ModSoundEvents.RIFT_START, class_3419.field_15245, 0.6f, 1);
		} else {
			// Place a rift at the target point
			if (target.getBlockState().method_26204() != ModBlocks.DETACHED_RIFT) {
				if (!target.getBlockState().method_26204().method_9616(world.method_8320(target.getBlockPos()), itemPlacementContext)) {
					player.method_7353(class_5250.method_43477(new class_2588("tools.target_became_block")), true);
					// Don't clear source, stabilized signatures always stay bound
					return class_1269.field_5814;
				}
				class_1937 targetWorld = DimensionalDoorsInitializer.getWorld(target.world);
				targetWorld.method_8501(target.getBlockPos(), ModBlocks.DETACHED_RIFT.method_9564());
				DetachedRiftBlockEntity rift1 = (DetachedRiftBlockEntity) target.getBlockEntity();
				rift1.register();
			}

			// Place a rift at the source point
			world.method_8501(pos, ModBlocks.DETACHED_RIFT.method_9564());
			DetachedRiftBlockEntity rift2 = (DetachedRiftBlockEntity) world.method_8321(pos);
			rift2.setDestination(RiftReference.tryMakeRelative(new Location((class_3218) world, pos), target));
			rift2.register();

			stack.method_7956(1, player, playerEntity -> {
			});

			player.method_7353(class_5250.method_43477(new class_2588(this.method_7876() + ".created")), true);
			world.method_8396(null, player.method_24515(), ModSoundEvents.RIFT_END, class_3419.field_15245, 0.6f, 1);
		}

		return class_1269.field_5812;
	}

	public static void setSource(class_1799 itemStack, RotatedLocation destination) {
		if (!itemStack.method_7985()) itemStack.method_7980(new class_2487());
		itemStack.method_7969().method_10566("destination", RotatedLocation.serialize(destination));
	}

	public static void clearSource(class_1799 itemStack) {
		if (itemStack.method_7985()) {
			itemStack.method_7969().method_10551("destination");
		}
	}

	public static RotatedLocation getTarget(class_1799 itemStack) {
		if (itemStack.method_7985() && itemStack.method_7969().method_10545("destination")) {
			return RotatedLocation.deserialize(itemStack.method_7969().method_10562("destination"));
		} else {
			return null;
		}
	}
}
