package org.dimdev.dimdoors.mixin;

import it.unimi.dsi.fastutil.objects.ObjectArrayList;
import org.dimdev.dimdoors.api.block.ExplosionConvertibleBlock;
import org.spongepowered.asm.mixin.Final;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.Mutable;
import org.spongepowered.asm.mixin.Shadow;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfo;

import java.util.stream.Collectors;
import net.minecraft.class_1269;
import net.minecraft.class_1927;
import net.minecraft.class_1937;
import net.minecraft.class_2248;
import net.minecraft.class_2338;
import net.minecraft.class_2680;

@Mixin(class_1927.class)
public class ExplosionMixin {
	@Mutable
	@Shadow
	@Final
	private ObjectArrayList<class_2338> affectedBlocks;

	@Shadow
	@Final
	private class_1937 world;

	@Inject(method = "affectWorld", at = @At(value = "INVOKE", target = "Lnet/minecraft/util/Util;shuffle(Lit/unimi/dsi/fastutil/objects/ObjectArrayList;Lnet/minecraft/util/math/random/Random;)V", ordinal = 0, shift = At.Shift.AFTER))
	private void handleExplosionConvertibleBlocks(boolean b1, CallbackInfo ci) {
		this.affectedBlocks = this.affectedBlocks.stream().filter(blockPos -> {
			class_2680 state = this.world.method_8320(blockPos);
			class_2248 block = state.method_26204();
			if (!(block instanceof ExplosionConvertibleBlock)) {
				return true;
			}
			class_1269 result = ((ExplosionConvertibleBlock) block).explode(this.world, blockPos, state, state.method_31709() ? this.world.method_8321(blockPos) : null);
			return result == class_1269.field_5811;
		}).collect(Collectors.toCollection(ObjectArrayList::new));
	}
}
