package org.dimdev.dimdoors.mixin;

import net.minecraft.class_1282;
import net.minecraft.class_1299;
import net.minecraft.class_1309;
import net.minecraft.class_1657;
import net.minecraft.class_1937;
import net.minecraft.class_2960;
import org.dimdev.dimdoors.DimensionalDoorsInitializer;
import org.dimdev.dimdoors.mixin.accessor.EntityAccessor;
import org.dimdev.dimdoors.world.ModDimensions;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.Shadow;
import org.spongepowered.asm.mixin.Unique;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfo;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfoReturnable;

@Mixin(value = class_1657.class, priority = 900)
public abstract class PlayerEntityMixin extends class_1309 {

	@Shadow
	public abstract void incrementStat(class_2960 stat);

	public PlayerEntityMixin(class_1299<? extends class_1309> entityType, class_1937 world) {
		super(entityType, world);
	}


	@Inject(method = "handleFallDamage", at = @At("HEAD"), cancellable = true)
	public void handleLimboFallDamage(float fallDistance, float damageMultiplier, class_1282 damageSource, CallbackInfoReturnable<Boolean> cir) {
		if (ModDimensions.isLimboDimension(field_6002)) {
			cir.setReturnValue(false);
		}
	}

	@Inject(method = "onDeath", at = @At("HEAD"), cancellable = true)
	public void checkDeath(class_1282 source, CallbackInfo ci) {
		this.doOnDeathStuff(source, ci);
	}

	@Unique
	protected void doOnDeathStuff(class_1282 source, CallbackInfo ci) {
		if (ModDimensions.isPocketDimension(this.field_6002) || DimensionalDoorsInitializer.getConfig().getLimboConfig().universalLimbo) {
			((EntityAccessor) this).setRemovalReason(null);
			this.field_6272 = false;
			this.method_6033(this.method_6063());
			ci.cancel();
		}
	}
}
