package org.dimdev.dimdoors.mixin;

import net.minecraft.class_1282;
import net.minecraft.class_1299;
import net.minecraft.class_1309;
import net.minecraft.class_1657;
import net.minecraft.class_1937;
import net.minecraft.class_2338;
import net.minecraft.class_2487;
import net.minecraft.class_2680;
import net.minecraft.class_3222;
import net.minecraft.class_3441;
import net.minecraft.class_5321;
import net.minecraft.class_5819;
import org.dimdev.dimdoors.api.util.TeleportUtil;
import org.dimdev.dimdoors.block.UnravelledFabricBlock;
import org.dimdev.dimdoors.criteria.ModCriteria;
import org.dimdev.dimdoors.entity.limbo.LimboEntranceSource;
import org.dimdev.dimdoors.entity.stat.ModStats;
import org.dimdev.dimdoors.world.ModDimensions;
import org.spongepowered.asm.mixin.Final;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.Shadow;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfo;

@Mixin(value = class_3222.class, priority = 900)
public abstract class ServerPlayerEntityMixin extends PlayerEntityMixin {
	@Shadow
	@Final
	private class_3441 recipeBook;

	@Shadow
	public abstract void method_5749(class_2487 nbt);

	private static final float RANDOM_ACTION_CHANCE = 0.1F;
	private static final float CHANCE_TO_MAKE_LIMBO_LIKE_OTHER_DIMENSIONS = 0.1F;
	private static final int CHUNK_SIZES = 25;
	private static final int POSITION_AWAY = 50;
	private static final float RANDOM_LIQUID_CHANCE = 0.7F;
	class_5819 field_5974 = class_5819.method_43047();

	public ServerPlayerEntityMixin(class_1299<? extends class_1309> entityType, class_1937 world) {
		super(entityType, world);
	}

	@Inject(method = "tick", at = @At("HEAD"), cancellable = true)
	public void playerTickMixin(CallbackInfo ci) {
		if (field_5974.method_43057() <= RANDOM_ACTION_CHANCE) {
			if(ModDimensions.isLimboDimension(((class_1657)(Object)(this)).method_5770())) {
				tryMakingLimboLikeOtherDimensions((class_1657)(Object)this);
			}
		}

	}
	private boolean isValidBlockToReplace(class_1937 world, class_2338 pos) {
		return world.method_8320(pos.method_10084()).method_26215() && world.method_8320(pos).method_26204() instanceof UnravelledFabricBlock;
	}
	private void makeLimboLikeOverworld(class_1657 player) {
		/*
		World world = player.getEntityWorld();
		BlockPos pos = player.getBlockPos().add(random.nextInt(random.nextInt(POSITION_AWAY)), 0, random.nextInt(POSITION_AWAY));
		if(random.nextFloat() <= RANDOM_LIQUID_CHANCE) {
			makeSpotOfLiquid(world, pos, Blocks.WATER.getDefaultState(), 3);
		}
		BlockPos.iterateOutwards(pos, CHUNK_SIZES, 15, CHUNK_SIZES).forEach( (blockPos -> {
			if(isValidBlockToReplace(world, blockPos)) {
				world.setBlockState(blockPos, Blocks.GRASS_BLOCK.getDefaultState());
			}

		}));

		 */

	}
	private void makeLimboLikeEnd(class_1657 player) {
		/*
		World world = player.getEntityWorld();
		BlockPos pos = player.getBlockPos().add(random.nextInt(POSITION_AWAY), 0, random.nextInt(POSITION_AWAY));
		BlockPos.iterateOutwards(pos, CHUNK_SIZES, 15, CHUNK_SIZES).forEach( (blockPos -> {
			if(isValidBlockToReplace(world, blockPos)) {
				world.setBlockState(blockPos, Blocks.END_STONE.getDefaultState());
			}

		}));

		 */
	}

	private void makeSpotOfLiquid(class_1937 world, class_2338 pos, class_2680 state, int range) {

		class_2338.method_25996(pos, field_5974.method_43048(range), field_5974.method_43048(range), field_5974.method_43048(range)).forEach( (blockPos -> {
			if(isValidBlockToReplace(world, blockPos)) {
				world.method_8501(blockPos, state);
			}

		}));

	}

	private void makeLimboLikeNether(class_1657 player) {
		/*
		World world = player.getEntityWorld();
		BlockPos pos = player.getBlockPos().add(random.nextInt(POSITION_AWAY), 0, random.nextInt(POSITION_AWAY));
		if(random.nextFloat() <= RANDOM_LIQUID_CHANCE) {
			makeSpotOfLiquid(world, pos, Blocks.LAVA.getDefaultState(), 10);
		}
		BlockPos.iterateOutwards(pos, CHUNK_SIZES, 15, CHUNK_SIZES).forEach( (blockPos -> {
			if(isValidBlockToReplace(world, blockPos)) {
				world.setBlockState(blockPos, Blocks.NETHERRACK.getDefaultState());
			}

		}));

		 */
	}
	private void tryMakingLimboLikeOtherDimensions(class_1657 player) {
		if(field_5974.method_43057() > CHANCE_TO_MAKE_LIMBO_LIKE_OTHER_DIMENSIONS) {
			return;
		}
		switch (field_5974.method_43048(3)) {
			case 0 : makeLimboLikeOverworld(player); break;
			case 1 : makeLimboLikeNether(player); break;
			case 2 : makeLimboLikeEnd(player); break;
		}
	}

	@Inject(method = "onDeath", at = @At("HEAD"), cancellable = true)
	public void checkDeathServer(class_1282 source, CallbackInfo ci) {
		this.doOnDeathStuff(source, ci);
		if (ci.isCancelled()) {
			if (ModDimensions.isPocketDimension(this.field_6002)) {
				this.incrementStat(ModStats.DEATHS_IN_POCKETS);
			}
			this.incrementStat(ModStats.TIMES_SENT_TO_LIMBO);
			TeleportUtil.teleportRandom(this, ModDimensions.LIMBO_DIMENSION, 384);
			//noinspection ConstantConditions
			LimboEntranceSource.ofDamageSource(source).broadcast((class_1657) (Object) this, this.method_5682());
		}
	}

	@Inject(method = "setSpawnPoint", at = @At("TAIL"))
	public void onSpawnPointSet(class_5321<class_1937> dimension, class_2338 pos, float angle, boolean spawnPointSet, boolean bl, CallbackInfo ci) {
		if (ModDimensions.isPocketDimension(dimension)) {
			ModCriteria.POCKET_SPAWN_POINT_SET.trigger((class_3222) (Object) this);
		}
	}


}
