package org.dimdev.dimdoors.mixin;

import org.dimdev.dimdoors.api.block.CustomBreakBlock;
import org.jetbrains.annotations.Nullable;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.ModifyVariable;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfoReturnable;
import org.spongepowered.asm.mixin.injection.callback.LocalCapture;

import java.util.function.Consumer;
import net.minecraft.class_1271;
import net.minecraft.class_1297;
import net.minecraft.class_1937;
import net.minecraft.class_2248;
import net.minecraft.class_2338;
import net.minecraft.class_2586;
import net.minecraft.class_2680;
import net.minecraft.class_3545;
import net.minecraft.class_3610;

@Mixin(class_1937.class)
public abstract class WorldMixin {

	/*
	I thought about redirecting the entire break method to be handled by the block itself,
	but I am not quite sure what that would mean for compatibility with other mixins,
	since then a large part of the method would need to be canceled. This is rather hacky, but it should fulfill the purpose best
	~CreepyCre
	 */
	@ModifyVariable(method = "breakBlock(Lnet/minecraft/util/math/BlockPos;ZLnet/minecraft/entity/Entity;I)Z",
			at = @At(value = "INVOKE_ASSIGN",
					target = "Lnet/minecraft/world/World;getFluidState(Lnet/minecraft/util/math/BlockPos;)Lnet/minecraft/fluid/FluidState;",
					ordinal = 0))
	private class_3610 replaceFluidStateWithCustomHackyFluidState(class_3610 original, class_2338 pos, boolean drop, @Nullable class_1297 breakingEntity, int maxUpdateDepth) { //TODO: Fix
		class_1937 world = (class_1937) (Object) this;
		class_2680 blockState = world.method_8320(pos);
		class_2248 block = blockState.method_26204();
		if (!(block instanceof CustomBreakBlock)) {
			return original;
		}
		class_1271<class_3545<class_2680, Consumer<class_2586>>> result = ((CustomBreakBlock) block).customBreakBlock(world, pos, blockState, breakingEntity);
		if (!result.method_5467().method_23665()) {
			return original;
		}
		class_3545<class_2680, Consumer<class_2586>> pair = result.method_5466();
		return new CustomBreakBlock.HackyFluidState(pair.method_15442(), pair.method_15441());
	}

	@Inject(method = "breakBlock(Lnet/minecraft/util/math/BlockPos;ZLnet/minecraft/entity/Entity;I)Z",
			locals = LocalCapture.CAPTURE_FAILHARD,
			at = @At(value = "INVOKE",
					target = "Lnet/minecraft/world/World;setBlockState(Lnet/minecraft/util/math/BlockPos;Lnet/minecraft/block/BlockState;II)Z",
					ordinal = 0,
					shift = At.Shift.AFTER))
	private void applyBlockEntityModification(class_2338 pos, boolean drop, class_1297 breakingEntity, int maxUpdateDepth, CallbackInfoReturnable<Boolean> cir, class_2680 blockState, class_3610 fluidState) {
		if (!(fluidState instanceof CustomBreakBlock.HackyFluidState)) {
			return;
		}
		Consumer<class_2586> blockEntityConsumer = ((CustomBreakBlock.HackyFluidState) fluidState).getBlockEntityConsumer();
		if (blockEntityConsumer == null) {
			return;
		}
		class_2586 blockEntity = ((class_1937) (Object) this).method_8321(pos);
		if (blockEntity != null) {
			blockEntityConsumer.accept(blockEntity);
		}
	}

	/*
	This is where I'd inject if it turns out the method used above does actually have an issue
	 */
//	@Inject(method = "Lnet/minecraft/world/World;breakBlock(Lnet/minecraft/util/math/BlockPos;ZLnet/minecraft/entity/Entity;I)Z",
//			cancellable = true,
//			at = @At(
//					value = "INVOKE",
//					target = "Lnet/minecraft/world/WorldAccess;syncWorldEvent(ILnet/minecraft/util/math/BlockPos;I)V",
//					ordinal = 0,
//					shift = At.Shift.BY,
//					by = 2
//			)
//	)


}
