package org.dimdev.dimdoors.mixin.client;

import com.mojang.blaze3d.systems.RenderSystem;
import net.minecraft.class_1088;
import net.minecraft.class_1159;
import net.minecraft.class_1921;
import net.minecraft.class_2338;
import net.minecraft.class_243;
import net.minecraft.class_310;
import net.minecraft.class_4184;
import net.minecraft.class_4583;
import net.minecraft.class_4587;
import net.minecraft.class_4588;
import net.minecraft.class_4599;
import net.minecraft.class_638;
import net.minecraft.class_757;
import net.minecraft.class_761;
import net.minecraft.class_765;
import net.minecraft.client.render.*;
import org.dimdev.dimdoors.client.CustomBreakBlockHandler;
import org.dimdev.dimdoors.listener.pocket.PocketListenerUtil;
import org.dimdev.dimdoors.world.ModDimensions;
import org.dimdev.dimdoors.world.pocket.type.addon.SkyAddon;
import org.spongepowered.asm.mixin.Final;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.Shadow;
import org.spongepowered.asm.mixin.Unique;
import org.spongepowered.asm.mixin.gen.Accessor;
import org.spongepowered.asm.mixin.gen.Invoker;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Constant;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.ModifyConstant;
import org.spongepowered.asm.mixin.injection.ModifyVariable;
import org.spongepowered.asm.mixin.injection.Slice;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfo;
import net.fabricmc.api.EnvType;
import net.fabricmc.api.Environment;

import java.util.List;
import java.util.Map;

@Mixin(class_761.class)
@Environment(EnvType.CLIENT)
public abstract class WorldRendererMixin {

	@Shadow
	private class_638 world;

	@Shadow
	private class_310 client;

	@Shadow
	@Final
	private class_4599 bufferBuilders;

	@Shadow
	private int ticks;

	@Inject(method = "render(Lnet/minecraft/client/util/math/MatrixStack;FJZLnet/minecraft/client/render/Camera;Lnet/minecraft/client/render/GameRenderer;Lnet/minecraft/client/render/LightmapTextureManager;Lnet/minecraft/util/math/Matrix4f;)V",
	at = @At(value = "FIELD", target = "Lnet/minecraft/client/render/WorldRenderer;blockBreakingProgressions:Lit/unimi/dsi/fastutil/longs/Long2ObjectMap;", ordinal = 1)) // bytecode order is flipped from java code order, notice the ordinal
	public void renderCustomBreakBlockAnimation(class_4587 matrices, float tickDelta, long limitTime, boolean renderBlockOutline, class_4184 camera, class_757 gameRenderer, class_765 lightmapTextureManager, class_1159 matrix4f, CallbackInfo ci) {
		class_243 vec3d = camera.method_19326();
		double d = vec3d.method_10216();
		double e = vec3d.method_10214();
		double f = vec3d.method_10215();

		Map<class_2338, CustomBreakBlockHandler.BreakBlockInfo> breakBlocks = CustomBreakBlockHandler.getCustomBreakBlockMap(this.ticks);

		// stolen from WorldRenderer#render
		for (Map.Entry<class_2338, CustomBreakBlockHandler.BreakBlockInfo> entry : breakBlocks.entrySet()) {
			class_2338 pos = entry.getKey();
			double h = (double) pos.method_10263() - d;
			double x = (double) pos.method_10264() - e;
			double y = (double) pos.method_10260() - f;
			if (!(h * h + x * x + y * y > 1024.0D)) {
				int stage = entry.getValue().getStage();
				matrices.method_22903();
				matrices.method_22904((double) pos.method_10263() - d, (double) pos.method_10264() - e, (double) pos.method_10260() - f);
				class_4587.class_4665 entry3 = matrices.method_23760();
				class_4588 vertexConsumer2 = new class_4583(this.bufferBuilders.method_23001().getBuffer((class_1921) class_1088.field_21772.get(stage)), entry3.method_23761(), entry3.method_23762());
				this.client.method_1541().method_23071(this.world.method_8320(pos), pos, this.world, matrices, vertexConsumer2);
				matrices.method_22909();
			}
		}
	}

//	TODO:Fix or find out alternative.
//	@ModifyConstant(
//			method = "renderSky(Lnet/minecraft/client/util/math/MatrixStack;Lnet/minecraft/util/math/Matrix4f;FLjava/lang/Runnable;)V",
//			constant = @Constant(doubleValue = 0.0, ordinal = 0),
//			slice = @Slice(
//					from = @At(
//							value = "INVOKE",
//							target = "Lnet/minecraft/client/world/ClientWorld$Properties;getSkyDarknessHeight(Lnet/minecraft/world/HeightLimitView;)D"
//					)
//			)
//	)
//	private double modifyVoidBackgroundCondition(double zero) {
//		if(ModDimensions.isPrivatePocketDimension(world)) {
//			zero = Double.NEGATIVE_INFINITY;
//		}
//		return zero;
//	}
}
