package org.dimdev.dimdoors.network.packet.s2c;

import net.fabricmc.api.EnvType;
import net.fabricmc.api.Environment;
import net.minecraft.class_1937;
import net.minecraft.class_2378;
import net.minecraft.class_2540;
import net.minecraft.class_2960;
import net.minecraft.class_5321;
import org.dimdev.dimdoors.network.client.ClientPacketListener;
import org.dimdev.dimdoors.network.SimplePacket;
import org.dimdev.dimdoors.world.pocket.type.addon.AutoSyncedAddon;

import java.io.IOException;
import java.util.List;

public class SyncPocketAddonsS2CPacket implements SimplePacket<ClientPacketListener> {
	public static final class_2960 ID = new class_2960("dimdoors:sync_pocket_addons");

	private class_5321<class_1937> world;
	private int gridSize;
	private int pocketId;
	private int pocketRange;
	private List<AutoSyncedAddon> addons;

	@Environment(EnvType.CLIENT)
	public SyncPocketAddonsS2CPacket() {
	}

	public SyncPocketAddonsS2CPacket(class_5321<class_1937> world, int gridSize, int pocketId, int pocketRange, List<AutoSyncedAddon> addons) {
		this.world = world;
		this.gridSize = gridSize;
		this.pocketId = pocketId;
		this.pocketRange = pocketRange;
		this.addons = addons;
	}

	@Override
	public SimplePacket<ClientPacketListener> read(class_2540 buf) throws IOException {
		this.world = class_5321.method_29179(class_2378.field_25298, buf.method_10810());
		this.gridSize = buf.readInt();
		this.pocketId = buf.readInt();
		this.pocketRange = buf.readInt();
		this.addons = AutoSyncedAddon.readAutoSyncedAddonList(buf);
		return this;
	}

	@Override
	public class_2540 write(class_2540 buf) throws IOException {
		buf.method_10812(world.method_29177());
		buf.writeInt(gridSize);
		buf.writeInt(pocketId);
		buf.writeInt(pocketRange);
		AutoSyncedAddon.writeAutoSyncedAddonList(buf, addons);
		return buf;
	}

	@Override
	public void apply(ClientPacketListener listener) {
		listener.onSyncPocketAddons(this);
	}

	@Override
	public class_2960 channelId() {
		return ID;
	}

	public int getGridSize() {
		return gridSize;
	}

	public int getPocketId() {
		return pocketId;
	}

	public int getPocketRange() {
		return pocketRange;
	}

	public List<AutoSyncedAddon> getAddons() {
		return addons;
	}

	public class_5321<class_1937> getWorld() {
		return world;
	}
}
