package org.dimdev.dimdoors.pockets;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.dimdev.dimdoors.DimensionalDoorsInitializer;
import org.dimdev.dimdoors.block.entity.RiftBlockEntity;
import org.dimdev.dimdoors.api.util.BlockPlacementType;
import org.dimdev.dimdoors.util.schematic.Schematic;
import org.dimdev.dimdoors.util.schematic.SchematicPlacer;
import org.dimdev.dimdoors.world.pocket.type.LazyGenerationPocket;
import org.dimdev.dimdoors.world.pocket.type.Pocket;
import java.util.Map;
import net.minecraft.class_1937;
import net.minecraft.class_2338;
import net.minecraft.class_2791;
import net.minecraft.class_2960;
import net.minecraft.class_3218;

public class PocketTemplate {
    private static final Logger LOGGER = LogManager.getLogger();
    private static final boolean replacingPlaceholders = false;
    private final Schematic schematic;
	private final class_2960 id;

	public PocketTemplate(Schematic schematic, class_2960 id) {
        this.schematic = schematic;
		this.id = id;
	}

    /*
    public void setup(Pocket pocket, VirtualTarget linkTo, LinkProperties linkProperties) {
        ServerWorld world = DimensionalDoorsInitializer.getWorld(pocket.world);

        List<RiftBlockEntity> rifts = new ArrayList<>();
        BlockPos origin = pocket.getOrigin();
        for (CompoundTag blockEntityTag : this.schematic.getBlockEntities()) {
            int[] pos = blockEntityTag.getIntArray("Pos");

            BlockPos actualBlock = origin.add(pos[0], pos[1], pos[2]);

            BlockEntity tile = world.getBlockEntity(actualBlock);

            if (tile instanceof RiftBlockEntity) {
                LOGGER.debug("Rift found in schematic at " + actualBlock);
                RiftBlockEntity rift = (RiftBlockEntity) tile;
                rift.getDestination().setLocation(new Location((ServerWorld) Objects.requireNonNull(rift.getWorld()), rift.getPos()));
                rifts.add(rift);
            } else if (tile instanceof Inventory) {
                Inventory inventory = (Inventory) tile;
                if (inventory.isEmpty()) {
                    if (tile instanceof ChestBlockEntity || tile instanceof DispenserBlockEntity) {
                        TemplateUtils.setupLootTable(world, tile, inventory, LOGGER);
                        if (inventory.isEmpty()) {
                            LOGGER.error(", however Inventory is: empty!");
                        }
                    }
                }
            }
        }

        TemplateUtils.registerRifts(rifts, linkTo, linkProperties, pocket);
    }
     */

    public void place(Pocket pocket, BlockPlacementType placementType) {
        pocket.setSize(schematic.getWidth(), schematic.getHeight(), schematic.getLength());
        class_3218 world = DimensionalDoorsInitializer.getWorld(pocket.getWorld());
        class_2338 origin = pocket.getOrigin();
		SchematicPlacer.place(this.schematic, world, origin, placementType);
    }

	public Map<class_2338, RiftBlockEntity> getAbsoluteRifts(Pocket pocket) {
		pocket.setSize(schematic.getWidth(), schematic.getHeight(), schematic.getLength());
		Map<class_2338, RiftBlockEntity> absoluteRifts = SchematicPlacer.getAbsoluteRifts(this.schematic, pocket.getOrigin());
		class_1937 world = DimensionalDoorsInitializer.getWorld(pocket.getWorld());
		absoluteRifts.values().forEach(rift -> rift.method_31662(world));
		return absoluteRifts;
	}

	public void place(LazyGenerationPocket pocket, class_2791 chunk, class_2338 originalOrigin, BlockPlacementType placementType) {
		SchematicPlacer.place(this.schematic, DimensionalDoorsInitializer.getWorld(pocket.getWorld()), chunk, originalOrigin, placementType);
	}

    public static boolean isReplacingPlaceholders() {
        return replacingPlaceholders;
    }

    public Schematic getSchematic() {
        return this.schematic;
    }

	public class_2960 getId() {
		return id;
	}
}
