package org.dimdev.dimdoors.pockets.modifier;

import java.util.*;
import java.util.function.Consumer;
import net.minecraft.class_1923;
import net.minecraft.class_1937;
import net.minecraft.class_2791;

public interface LazyCompatibleModifier extends Modifier {
	LinkedHashMap<class_1923, Queue<Consumer<class_2791>>> chunkModificationQueue = new LinkedHashMap<>();

	static void runQueuedModifications(class_2791 chunk) {
		Queue<Consumer<class_2791>> tasks = chunkModificationQueue.remove(chunk.method_12004());
		if (tasks == null) return;
		Iterator<Consumer<class_2791>> iterator = tasks.iterator();
		while (iterator.hasNext()) {
			Consumer<class_2791> task = iterator.next();
			iterator.remove();
			task.accept(chunk);
		}
	}

	static void runLeftoverModifications(class_1937 world) {
		new HashSet<>(chunkModificationQueue.keySet()).forEach(chunkPos -> world.method_22350(chunkPos.method_8323())); // seems safest for Cubic Chunks reasons;
	}

	default void queueChunkModificationTask(class_1923 pos, Consumer<class_2791> task) {
		chunkModificationQueue.compute(pos, ((chunkPos, chunkTaskQueue) -> {
			if (chunkTaskQueue == null) chunkTaskQueue = new LinkedList<>();
			chunkTaskQueue.add(task);
			return chunkTaskQueue;
		}));
	}
}
