package org.dimdev.dimdoors.pockets.modifier;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.dimdev.dimdoors.pockets.PocketGenerationContext;
import org.dimdev.dimdoors.api.util.math.Equation;
import org.dimdev.dimdoors.world.pocket.type.Pocket;

import java.util.HashMap;
import java.util.Map;
import net.minecraft.class_2382;
import net.minecraft.class_2487;
import net.minecraft.class_3300;

public class OffsetModifier extends AbstractModifier {
	private static final Logger LOGGER = LogManager.getLogger();
	public static final String KEY = "offset";

	private String offsetX;
	private Equation offsetXEquation;
	private String offsetY;
	private Equation offsetYEquation;
	private String offsetZ;
	private Equation offsetZEquation;

	@Override
	public Modifier fromNbt(class_2487 nbt, class_3300 manager) {
		try {
			offsetX = nbt.method_10545("offset_x") ? nbt.method_10558("offset_x") : "0";
			offsetXEquation = Equation.parse(offsetX);
			offsetY = nbt.method_10545("offset_y") ? nbt.method_10558("offset_y") : "0";
			offsetYEquation = Equation.parse(offsetY);
			offsetZ = nbt.method_10545("offset_z") ? nbt.method_10558("offset_z") : "0";
			offsetZEquation = Equation.parse(offsetZ);
		} catch (Equation.EquationParseException e) {
			LOGGER.error(e);
		}

		return this;
	}

	@Override
	public class_2487 toNbtInternal(class_2487 nbt, boolean allowReference) {
		super.toNbtInternal(nbt, allowReference);

		if (!offsetX.equals("0")) nbt.method_10582("offset_x", offsetX);
		if (!offsetY.equals("0")) nbt.method_10582("offset_y", offsetY);
		if (!offsetZ.equals("0")) nbt.method_10582("offset_z", offsetZ);

		return nbt;
	}

	@Override
	public ModifierType<? extends Modifier> getType() {
		return ModifierType.OFFSET_MODIFIER_TYPE;
	}

	@Override
	public String getKey() {
		return KEY;
	}

	@Override
	public void apply(PocketGenerationContext parameters, RiftManager manager) {

	}

	@Override
	public void apply(PocketGenerationContext parameters, Pocket.PocketBuilder<?, ?> builder) {
		Map<String, Double> variableMap = parameters.toVariableMap(new HashMap<>());
		builder.offsetOrigin(new class_2382((int) offsetXEquation.apply(variableMap), (int) offsetYEquation.apply(variableMap), (int) offsetZEquation.apply(variableMap)));
	}
}
