package org.dimdev.dimdoors.rift.registry;

import java.util.UUID;
import net.minecraft.class_2487;
import net.minecraft.class_4844;
import com.mojang.serialization.Codec;
import com.mojang.serialization.codecs.RecordCodecBuilder;

public class PlayerRiftPointer extends RegistryVertex {
	public static final Codec<PlayerRiftPointer> CODEC = RecordCodecBuilder.create(instance -> {
		return instance.group(
				class_4844.field_25122.fieldOf("id").forGetter(a -> a.id),
				class_4844.field_25122.fieldOf("player").forGetter(a -> a.player)
		).apply(instance, (id, player) -> {
			PlayerRiftPointer pointer = new PlayerRiftPointer(player);
			pointer.id = id;
			return pointer;
		});
	});

	private final UUID player;

	public PlayerRiftPointer(UUID player) {
		this.player = player;
	}

	@Override
	public RegistryVertexType<? extends RegistryVertex> getType() {
		return RegistryVertexType.PLAYER;
	}

	public String toString() {
		return "PlayerRiftPointer(player=" + this.player + ")";
	}

	public static class_2487 toNbt(PlayerRiftPointer vertex) {
		class_2487 nbt = new class_2487();
		nbt.method_25927("id", vertex.id);
		nbt.method_25927("player", vertex.player);
		return nbt;
	}

	public static PlayerRiftPointer fromNbt(class_2487 nbt) {
		return new PlayerRiftPointer(nbt.method_25926("id"));
	}

	public UUID getPlayer() {
		return player;
	}
}
