package org.dimdev.dimdoors.rift.targets;

import net.minecraft.class_1297;
import net.minecraft.class_2379;
import net.minecraft.class_243;
import net.minecraft.class_2588;
import net.minecraft.class_5250;
import org.dimdev.dimdoors.api.rift.target.EntityTarget;
import org.dimdev.dimdoors.api.rift.target.Target;
import org.dimdev.dimdoors.api.util.EntityUtils;

public class MessageTarget implements EntityTarget {
	private final Target forwardTo;
	private final String message;
	private final Object[] messageParams;

	public MessageTarget(Target forwardTo, String message, Object... messageParams) {
		this.forwardTo = forwardTo;
		this.message = message;
		this.messageParams = messageParams;
	}

	public MessageTarget(String message, Object... messageParams) {
		this(null, message, messageParams);
	}

	@Override
	public boolean receiveEntity(class_1297 entity, class_243 relativePos, class_2379 relativeAngle, class_243 relativeVelocity) {
		EntityUtils.chat(entity, class_5250.method_43477(new class_2588(this.message, this.messageParams)));

		if (this.forwardTo != null) {
			this.forwardTo.as(Targets.ENTITY).receiveEntity(entity, relativePos, relativeAngle, relativeVelocity);
			return true;
		} else {
			return false;
		}
	}
}
