package org.dimdev.dimdoors.rift.targets;

import net.minecraft.class_1297;
import net.minecraft.class_2379;
import net.minecraft.class_243;
import net.minecraft.class_2487;
import net.minecraft.class_2588;
import net.minecraft.class_5250;
import org.apache.commons.lang3.builder.ToStringBuilder;
import org.dimdev.dimdoors.api.rift.target.EntityTarget;
import org.dimdev.dimdoors.api.util.EntityUtils;

public class PocketEntranceMarker extends VirtualTarget implements EntityTarget {
	private final float weight;
	private final VirtualTarget ifDestination;
	private final VirtualTarget otherwiseDestination;

	public PocketEntranceMarker() {
		this(1, NoneTarget.INSTANCE, NoneTarget.INSTANCE);
	}

	public PocketEntranceMarker(float weight, VirtualTarget ifDestination, VirtualTarget otherwiseDestination) {
		this.weight = weight;
		this.ifDestination = ifDestination;
		this.otherwiseDestination = otherwiseDestination;
	}

	public static PocketEntranceMarkerBuilder builder() {
		return new PocketEntranceMarkerBuilder();
	}

	@Override
	public boolean receiveEntity(class_1297 entity, class_243 relativePos, class_2379 relativeAngle, class_243 relativeVelocity) {
		EntityUtils.chat(entity, class_5250.method_43477(new class_2588("The entrance of this dungeon has not been converted. If this is a normally generated pocket, please report this bug.")));
		return false;
	}

	public float getWeight() {
		return this.weight;
	}

	public VirtualTarget getIfDestination() {
		return this.ifDestination;
	}

	public VirtualTarget getOtherwiseDestination() {
		return this.otherwiseDestination;
	}

	public String toString() {
		return "PocketEntranceMarker(weight=" + this.getWeight() + ", ifDestination=" + this.getIfDestination() + ", otherwiseDestination=" + this.getOtherwiseDestination() + ")";
	}

	public PocketEntranceMarkerBuilder toBuilder() {
		return new PocketEntranceMarkerBuilder().weight(this.weight).ifDestination(this.ifDestination).otherwiseDestination(this.otherwiseDestination);
	}

	@Override
	public VirtualTargetType<? extends VirtualTarget> getType() {
		return VirtualTargetType.POCKET_ENTRANCE;
	}

	public static class_2487 toNbt(PocketEntranceMarker target) {
		class_2487 nbt = new class_2487();
		nbt.method_10548("weight", target.weight);
		nbt.method_10566("ifDestination", VirtualTarget.toNbt(target.ifDestination));
		nbt.method_10566("otherwiseDestination", VirtualTarget.toNbt(target.otherwiseDestination));
		return nbt;
	}

	public static PocketEntranceMarker fromNbt(class_2487 nbt) {
		return PocketEntranceMarker.builder()
				.weight(nbt.method_10583("weight"))
				.ifDestination(nbt.method_10545("ifDestination") ? VirtualTarget.fromNbt(nbt.method_10562("ifDestination")) : NoneTarget.INSTANCE)
				.otherwiseDestination(nbt.method_10545("otherwiseDestination") ? VirtualTarget.fromNbt(nbt.method_10562("otherwiseDestination")) : NoneTarget.INSTANCE)
				.build();
	}

	public static class PocketEntranceMarkerBuilder {
		private float weight;
		private VirtualTarget ifDestination = NoneTarget.INSTANCE;
		private VirtualTarget otherwiseDestination = NoneTarget.INSTANCE;

		private PocketEntranceMarkerBuilder() {
		}

		public PocketEntranceMarker.PocketEntranceMarkerBuilder weight(float weight) {
			this.weight = weight;
			return this;
		}

		public PocketEntranceMarker.PocketEntranceMarkerBuilder ifDestination(VirtualTarget ifDestination) {
			this.ifDestination = ifDestination;
			return this;
		}

		public PocketEntranceMarker.PocketEntranceMarkerBuilder otherwiseDestination(VirtualTarget otherwiseDestination) {
			this.otherwiseDestination = otherwiseDestination;
			return this;
		}

		public PocketEntranceMarker build() {
			return new PocketEntranceMarker(this.weight, this.ifDestination, this.otherwiseDestination);
		}

		@Override
		public String toString() {
			return new ToStringBuilder(this)
					.append("weight", weight)
					.append("ifDestination", ifDestination)
					.append("otherwiseDestination", otherwiseDestination)
					.toString();
		}
	}
}
