package org.dimdev.dimdoors.rift.targets;

import net.minecraft.class_2350;
import net.minecraft.class_2588;
import net.minecraft.class_3611;
import net.minecraft.class_5250;
import org.dimdev.dimdoors.api.rift.target.*;
import org.dimdev.dimdoors.api.util.EntityUtils;

// A list of the default targets provided by dimcore. Add your own in ModTargets
public final class Targets {
	public static final Class<EntityTarget> ENTITY = EntityTarget.class;
	public static final Class<ItemTarget> ITEM = ItemTarget.class;
	public static final Class<FluidTarget> FLUID = FluidTarget.class;
	public static final Class<RedstoneTarget> REDSTONE = RedstoneTarget.class;

	public static void registerDefaultTargets() {
		DefaultTargets.registerDefaultTarget(ENTITY, (entity, relativePos, relativeRotation, relativeVelocity) -> {
			EntityUtils.chat(entity, class_5250.method_43477(new class_2588("rifts.unlinked2")));
			return false;
		});
		DefaultTargets.registerDefaultTarget(ITEM, stack -> false);

		DefaultTargets.registerDefaultTarget(FLUID, new FluidTarget() {
			@Override
			public boolean addFluidFlow(class_2350 relativeFacing, class_3611 fluid, int level) {
				return false;
			}

			@Override
			public void subtractFluidFlow(class_2350 relativeFacing, class_3611 fluid, int level) {
				throw new RuntimeException("Subtracted fluid flow that was never accepted");
			}
		});

		DefaultTargets.registerDefaultTarget(REDSTONE, new RedstoneTarget() {
			@Override
			public boolean addRedstonePower(class_2350 relativeFacing, int strength) {
				return false;
			}

			@Override
			public void subtractRedstonePower(class_2350 relativeFacing, int strength) {
				throw new RuntimeException("Subtracted redstone that was never accepted");
			}
		});
	}
}
