package org.dimdev.dimdoors.util.schematic;

import com.mojang.brigadier.StringReader;
import com.mojang.brigadier.exceptions.CommandSyntaxException;
import com.mojang.serialization.Codec;
import com.mojang.serialization.DataResult;
import com.mojang.serialization.codecs.UnboundedMapCodec;
import java.util.Iterator;
import java.util.Objects;
import net.minecraft.class_2259;
import net.minecraft.class_2378;
import net.minecraft.class_2680;
import net.minecraft.class_2769;
import net.minecraft.class_3542;

public class SchematicBlockPalette {
	public static final UnboundedMapCodec<class_2680, Integer> CODEC = Codec.unboundedMap(Entry.CODEC, Codec.INT);

	private static <T extends Comparable<T>> class_2680 process(class_2769<T> property, String value, class_2680 state) {
		return state.method_11657(property, property.method_11900(value).orElseThrow(NullPointerException::new));
	}

	public interface Entry {
		Codec<class_2680> CODEC = Codec.STRING.comapFlatMap(Entry::to, Entry::from);

		static DataResult<class_2680> to(String string) {
			StringReader reader = new StringReader(string);

			class_2259.class_7211 parser = null;

			try {
				parser = class_2259.method_41956(class_2378.field_11146, reader, true);
			} catch (CommandSyntaxException e) {
				return DataResult.error(e.getMessage());
			}
			return DataResult.success(parser.comp_622());
//			if (!string.contains("[") && !string.contains("]")) {
//				BlockState state = Registry.BLOCK.get(new Identifier(string)).getDefaultState();
//				return DataResult.success(state);
//			} else {
//				Block block = Objects.requireNonNull(Registry.BLOCK.get(new Identifier(string.substring(0, string.indexOf("[")))));
//				BlockState state = block.getDefaultState();
//
//				String[] stateArray = string.substring(string.indexOf("[") + 1, string.length() - 1).split(",");
//				for (String stateString : stateArray) {
//					Property<?> property;
//					try {
//						property = Objects.requireNonNull(block.getStateManager().getProperty(stateString.split("=")[0]));
//					} catch (RuntimeException e) {
//						return DataResult.error("Unknown block state property \"" + stateString + "\"", state);
//					}
//					state = process(property, stateString.split("=")[1], state);
//				}
//
//				return DataResult.success(state);
//			}
		}

		static String from(class_2680 state) {
			StringBuilder builder = new StringBuilder();
			builder.append(Objects.requireNonNull(class_2378.field_11146.method_10221(state.method_26204())));
			// Ensures that [ and ] are only added when properties are present
			boolean flag = true;
			Iterator<class_2769<?>> iterator = state.method_28501().iterator();
			while (iterator.hasNext()) {
				if (flag) {
					builder.append("[");
					flag = false;
				}

				class_2769<?> property = iterator.next();
				builder.append(property.method_11899());
				builder.append("=");

				if (state.method_11654(property) instanceof Enum<?>) {
					// Enum might have override toString
					builder.append(((class_3542) state.method_11654(property)).method_15434());
				} else {
					builder.append(state.method_11654(property).toString());
				}

				if (iterator.hasNext()) {
					builder.append(",");
				}
			}
			if (!flag) {
				builder.append("]");
			}
			return builder.toString();
		}
	}
}
