package org.dimdev.dimdoors.world;

import net.minecraft.class_1311;
import net.minecraft.class_1959;
import net.minecraft.class_2378;
import net.minecraft.class_2893;
import net.minecraft.class_2960;
import net.minecraft.class_4761;
import net.minecraft.class_4763;
import net.minecraft.class_4968;
import net.minecraft.class_5195;
import net.minecraft.class_5321;
import net.minecraft.class_5458;
import net.minecraft.class_5483;
import net.minecraft.class_5485;
import org.dimdev.dimdoors.entity.ModEntityTypes;
import org.dimdev.dimdoors.particle.ModParticleTypes;
import org.dimdev.dimdoors.sound.ModSoundEvents;
import org.dimdev.dimdoors.world.feature.ModFeatures;

public final class ModBiomes {
    public static final class_5321<class_1959> PERSONAL_WHITE_VOID_KEY;
    public static final class_5321<class_1959> PUBLIC_BLACK_VOID_KEY;
    public static final class_5321<class_1959> DUNGEON_DANGEROUS_BLACK_VOID_KEY;
    public static final class_5321<class_1959> LIMBO_KEY;
    public static final class_1959 PERSONAL_WHITE_VOID_BIOME;
    public static final class_1959 PUBLIC_BLACK_VOID_BIOME;
    public static final class_1959 DUNGEON_DANGEROUS_BLACK_VOID_BIOME;
    public static final class_1959 LIMBO_BIOME;

    public static void init() {
        class_2378.method_10230(class_5458.field_25933, LIMBO_KEY.method_29177(), LIMBO_BIOME);
        class_2378.method_10230(class_5458.field_25933, PERSONAL_WHITE_VOID_KEY.method_29177(), PERSONAL_WHITE_VOID_BIOME);
        class_2378.method_10230(class_5458.field_25933, PUBLIC_BLACK_VOID_KEY.method_29177(), PUBLIC_BLACK_VOID_BIOME);
        class_2378.method_10230(class_5458.field_25933, DUNGEON_DANGEROUS_BLACK_VOID_KEY.method_29177(), DUNGEON_DANGEROUS_BLACK_VOID_BIOME);
        // only ever needed if the biome api is broken
//        BuiltinBiomesAccessor.getIdMap().put(BuiltinRegistries.BIOME.getRawId(LIMBO_BIOME), LIMBO_KEY);
//        BuiltinBiomesAccessor.getIdMap().put(BuiltinRegistries.BIOME.getRawId(PERSONAL_WHITE_VOID_BIOME), PERSONAL_WHITE_VOID_KEY);
//        BuiltinBiomesAccessor.getIdMap().put(BuiltinRegistries.BIOME.getRawId(PUBLIC_BLACK_VOID_BIOME), PUBLIC_BLACK_VOID_KEY);
//        BuiltinBiomesAccessor.getIdMap().put(BuiltinRegistries.BIOME.getRawId(DUNGEON_DANGEROUS_BLACK_VOID_BIOME), DUNGEON_DANGEROUS_BLACK_VOID_KEY);
    }

    private static class_4763 createEffect(boolean white) {
        class_4763.class_4764 builder = new class_4763.class_4764()
                .method_24395(0x3f76e4)
                .method_24397(0x50533)
                .method_24392(white ? 0xFFFFFF : 0x000000)
                .method_30820(white ? 0xFFFFFF : 0x000000)
                .method_30818(class_4763.class_5486.field_26426);
        if (white) {
            builder.method_27346(new class_5195(ModSoundEvents.WHITE_VOID, 0, 0, true));
        }
        return builder.method_24391();
    }

    static {

        class_1959.class_1960 voidBiomeBuilder = new class_1959.class_1960()
//				.category(Biome.Category.NONE) //TODO: Find out analog or if needed?
				.method_8727(0)
				.method_30973(new class_5485.class_5495().method_30987())
				.method_8735(class_1959.class_1963.field_9384)
				.method_30974(new class_5483.class_5496().method_31007())
				.method_8747(0.8f)
				.method_30777(class_1959.class_5484.field_26407);
        PERSONAL_WHITE_VOID_KEY = class_5321.method_29179(class_2378.field_25114, new class_2960("dimdoors:white_void"));
        PUBLIC_BLACK_VOID_KEY = class_5321.method_29179(class_2378.field_25114, new class_2960("dimdoors:black_void"));
        DUNGEON_DANGEROUS_BLACK_VOID_KEY = class_5321.method_29179(class_2378.field_25114, new class_2960("dimdoors:dangerous_black_void"));
        LIMBO_KEY = class_5321.method_29179(class_2378.field_25114, new class_2960("dimdoors", "limbo"));
        PERSONAL_WHITE_VOID_BIOME = voidBiomeBuilder.method_24379(createEffect(true)).method_30972();
        PUBLIC_BLACK_VOID_BIOME = voidBiomeBuilder.method_24379(createEffect(false)).method_30972();
        DUNGEON_DANGEROUS_BLACK_VOID_BIOME = voidBiomeBuilder.method_24379(createEffect(false)).method_30972();
        LIMBO_BIOME = new class_1959.class_1960()
//                .category(Biome.Category.NONE) TODO: FInd if needed
                .method_8727(0.0f)
                .method_24379(new class_4763.class_4764()
                        .method_24392(0x404040)
                        .method_24395(0x101010)
                        .method_30821(0)
                        .method_24397(0)
                        .method_24943(new class_4968(ModSoundEvents.CRACK, 6000, 8, 2.0))
						.method_27346(new class_5195(ModSoundEvents.CREEPY, 0, 0, true))
                        .method_30820(0x404040)
                        .method_30822(0)
						.method_24393(new class_4761(ModParticleTypes.LIMBO_ASH, 0.118093334F))
                        .method_24391()
				)
                .method_30973(new class_5485.class_5495()
						.method_30992(
								class_2893.class_2895.field_13173,
								ModFeatures.Placed.LIMBO_GATEWAY_PLACED_FEATURE
						)
						.method_30992(
								class_2893.class_2895.field_13176,
								ModFeatures.Placed.SOLID_STATIC_ORE_PLACED_FEATURE
						)
//						.feature(
//								GenerationStep.Feature.UNDERGROUND_ORES,
//								ModFeatures.Placed.DECAYED_BLOCK_ORE_PLACED_FEATURE
//						)
                        .method_30987()
				)
                .method_8735(class_1959.class_1963.field_9384)
                .method_30974(new class_5483.class_5496()
						.method_31008(0.02f)
						.method_31011(
								class_1311.field_6302,
								new class_5483.class_1964(
										ModEntityTypes.MONOLITH,
										100,
										1,
										1
								)
						)
                        .method_31007()
				)
                .method_8747(0.2f)
                .method_30777(class_1959.class_5484.field_26407)
                .method_30972();
    }
}
