package org.dimdev.dimdoors.world.decay;

import java.util.Set;
import java.util.function.Supplier;

import com.mojang.serialization.Lifecycle;
import org.dimdev.dimdoors.DimensionalDoorsInitializer;
import org.dimdev.dimdoors.world.decay.predicates.SimpleDecayPredicate;
import org.dimdev.dimdoors.world.decay.processors.SimpleDecayProcesor;
import net.fabricmc.fabric.api.event.registry.FabricRegistryBuilder;
import net.minecraft.class_1937;
import net.minecraft.class_2248;
import net.minecraft.class_2338;
import net.minecraft.class_2370;
import net.minecraft.class_2378;
import net.minecraft.class_2487;
import net.minecraft.class_2680;
import net.minecraft.class_2960;
import net.minecraft.class_5321;

public interface DecayPredicate {
    class_2378<DecayPredicateType<? extends DecayPredicate>> REGISTRY = FabricRegistryBuilder.from(new class_2370<DecayPredicateType<? extends DecayPredicate>>(class_5321.method_29180(new class_2960("dimdoors", "decay_predicate_type")), Lifecycle.stable(), null)).buildAndRegister();

    DecayPredicate NONE = new DecayPredicate() {
        private static final String ID = "none";

        @Override
        public DecayPredicate fromNbt(class_2487 nbt) {
            return this;
        }

        @Override
        public DecayPredicateType<? extends DecayPredicate> getType() {
            return DecayPredicateType.NONE_PREDICATE_TYPE;
        }

        @Override
        public String getKey() {
            return ID;
        }

        @Override
        public boolean test(class_1937 world, class_2338 pos, class_2680 origin, class_2680 target) {
            return false;
        }

		@Override
		public Set<class_2248> constructApplicableBlocks() {
			return Set.of();
		}
	};

    static DecayPredicate deserialize(class_2487 nbt) {
        class_2960 id = class_2960.method_12829(nbt.method_10558("type"));
        return REGISTRY.method_17966(id).orElse(DecayPredicateType.NONE_PREDICATE_TYPE).fromNbt(nbt);
    }

    static class_2487 serialize(DecayPredicate modifier) {
        return modifier.toNbt(new class_2487());
    }


    DecayPredicate fromNbt(class_2487 nbt);

    default class_2487 toNbt(class_2487 nbt) {
        return this.getType().toNbt(nbt);
    }

    DecayPredicate.DecayPredicateType<? extends DecayPredicate> getType();

    String getKey();

    boolean test(class_1937 world, class_2338 pos, class_2680 origin, class_2680 target);

    Set<class_2248> constructApplicableBlocks();

    interface DecayPredicateType<T extends DecayPredicate> {
        DecayPredicateType<DecayPredicate> NONE_PREDICATE_TYPE = register(new class_2960("dimdoors", "none"), () -> NONE);
        DecayPredicateType<SimpleDecayPredicate> SIMPLE_PREDICATE_TYPE = register(new class_2960("dimdoors", SimpleDecayProcesor.KEY), SimpleDecayPredicate::new);

        DecayPredicate fromNbt(class_2487 nbt);

		class_2487 toNbt(class_2487 nbt);

        static void register() {
            DimensionalDoorsInitializer.apiSubscribers.forEach(d -> d.registerDecayPredicates(REGISTRY));
        }

        static <U extends DecayPredicate> DecayPredicateType<U> register(class_2960 id, Supplier<U> factory) {
            return class_2378.method_10230(REGISTRY, id, new DecayPredicateType<U>() {
                @Override
                public DecayPredicate fromNbt(class_2487 nbt) {
                    return factory.get().fromNbt(nbt);
                }

                @Override
                public class_2487 toNbt(class_2487 nbt) {
					nbt.method_10582("type", id.toString());
                    return nbt;
                }
            });
        }
    }
}
