package org.dimdev.dimdoors.world.decay;

import java.util.function.Supplier;

import com.mojang.serialization.Lifecycle;
import org.dimdev.dimdoors.DimensionalDoorsInitializer;
import org.dimdev.dimdoors.world.decay.processors.SelfDecayProcessor;
import org.dimdev.dimdoors.world.decay.processors.SimpleDecayProcesor;
import net.fabricmc.fabric.api.event.registry.FabricRegistryBuilder;
import net.minecraft.class_1937;
import net.minecraft.class_2338;
import net.minecraft.class_2370;
import net.minecraft.class_2378;
import net.minecraft.class_2487;
import net.minecraft.class_2680;
import net.minecraft.class_2960;
import net.minecraft.class_5321;

public interface DecayProcessor {
    class_2378<DecayProcessor.DecayProcessorType<? extends DecayProcessor>> REGISTRY = FabricRegistryBuilder.from(new class_2370<DecayProcessor.DecayProcessorType<? extends DecayProcessor>>(class_5321.method_29180(new class_2960("dimdoors", "decay_processor_type")), Lifecycle.stable(), null)).buildAndRegister();

    DecayProcessor NONE = new DecayProcessor() {
        @Override
        public DecayProcessor fromNbt(class_2487 nbt) {
            return this;
        }

        @Override
        public DecayProcessorType<? extends DecayProcessor> getType() {
            return DecayProcessor.DecayProcessorType.NONE_PROCESSOR_TYPE;
        }

        @Override
        public String getKey() {
            return ID;
        }

        @Override
        public int process(class_1937 world, class_2338 pos, class_2680 origin, class_2680 target) {
            return 0;
        }

        private static final String ID = "none";
    };

    static DecayProcessor deserialize(class_2487 nbt) {
        class_2960 id = class_2960.method_12829(nbt.method_10558("type"));
        return REGISTRY.method_17966(id).orElse(DecayProcessorType.NONE_PROCESSOR_TYPE).fromNbt(nbt);
    }

    static class_2487 serialize(DecayProcessor modifier) {
        return modifier.toNbt(new class_2487());
    }


    DecayProcessor fromNbt(class_2487 nbt);

    default class_2487 toNbt(class_2487 nbt) {
        return this.getType().toNbt(nbt);
    }

    DecayProcessor.DecayProcessorType<? extends DecayProcessor> getType();

    String getKey();

    int process(class_1937 world, class_2338 pos, class_2680 origin, class_2680 target);

    interface DecayProcessorType<T extends DecayProcessor> {
        DecayProcessorType<SimpleDecayProcesor> SIMPLE_PROCESSOR_TYPE = register(new class_2960("dimdoors", SimpleDecayProcesor.KEY), SimpleDecayProcesor::new);
        DecayProcessorType<DecayProcessor> NONE_PROCESSOR_TYPE = register(new class_2960("dimdoors", "none"), () -> NONE);
        DecayProcessorType<SelfDecayProcessor> SELF = register(new class_2960("dimdoors", SelfDecayProcessor.KEY), SelfDecayProcessor::instance);

        DecayProcessor fromNbt(class_2487 nbt);

		class_2487 toNbt(class_2487 nbt);

        static void register() {
            DimensionalDoorsInitializer.apiSubscribers.forEach(d -> d.registerDecayProcessors(REGISTRY));
        }

        static <U extends DecayProcessor> DecayProcessorType<U> register(class_2960 id, Supplier<U> factory) {
            return class_2378.method_10230(REGISTRY, id, new DecayProcessorType<U>() {
                @Override
                public DecayProcessor fromNbt(class_2487 nbt) {
                    return factory.get().fromNbt(nbt);
                }

                @Override
                public class_2487 toNbt(class_2487 nbt) {
                    nbt.method_10582("type", id.toString());
                    return nbt;
                }
            });
        }
    }
}
