package org.dimdev.dimdoors.world.decay.predicates;

import com.google.gson.JsonObject;
import org.dimdev.dimdoors.world.decay.DecayPredicate;
import java.util.Set;
import net.minecraft.class_1937;
import net.minecraft.class_2246;
import net.minecraft.class_2248;
import net.minecraft.class_2338;
import net.minecraft.class_2378;
import net.minecraft.class_2487;
import net.minecraft.class_2680;
import net.minecraft.class_2960;

public class SimpleDecayPredicate implements DecayPredicate {
    public static final String KEY = "simple";

    private class_2248 block;

    public SimpleDecayPredicate() {}

    private SimpleDecayPredicate(class_2248 block) {
        this.block = block;
    }

    @Override
    public DecayPredicate fromNbt(class_2487 nbt) {
        block = class_2378.field_11146.method_10223(class_2960.method_12829(nbt.method_10558("block")));
        return this;
    }

    @Override
    public class_2487 toNbt(class_2487 nbt) {
        DecayPredicate.super.toNbt(nbt);
        nbt.method_10582("block", class_2378.field_11146.method_10221(block).toString());
        return nbt;
    }

    @Override
    public DecayPredicateType<? extends DecayPredicate> getType() {
        return DecayPredicateType.SIMPLE_PREDICATE_TYPE;
    }

    @Override
    public String getKey() {
        return KEY;
    }

    @Override
    public boolean test(class_1937 world, class_2338 pos, class_2680 origin, class_2680 target) {
        class_2680 state = world.method_8320(pos);

        return state.method_26204() == block;
    }

	@Override
	public Set<class_2248> constructApplicableBlocks() {
		return Set.of(block);
	}

	public static Builder builder() {
        return new Builder();
    }

    public static class Builder {
        private class_2248 block = class_2246.field_10124;

        public Builder block(class_2248 block) {
            this.block = block;
            return this;
        }

        public SimpleDecayPredicate create() {
            return new SimpleDecayPredicate(block);
        }
    }
}
