package org.dimdev.dimdoors.world.decay.processors;

import com.google.gson.JsonObject;
import org.dimdev.dimdoors.world.decay.DecayProcessor;
import java.util.Set;
import java.util.stream.Collectors;
import net.minecraft.class_1937;
import net.minecraft.class_2246;
import net.minecraft.class_2248;
import net.minecraft.class_2338;
import net.minecraft.class_2378;
import net.minecraft.class_2487;
import net.minecraft.class_2680;
import net.minecraft.class_2769;
import net.minecraft.class_2960;

public class SimpleDecayProcesor implements DecayProcessor {
    public static final String KEY = "simple";

    private class_2248 block;

    private int entropy;

    public SimpleDecayProcesor() {}

    private SimpleDecayProcesor(class_2248 block, int entropy) {
        this.block = block;
        this.entropy = entropy;
    }

    @Override
    public DecayProcessor fromNbt(class_2487 json) {
        block = class_2378.field_11146.method_10223(class_2960.method_12829(json.method_10558("block")));
        entropy = json.method_10550("entropy");
        return this;
    }

    @Override
    public class_2487 toNbt(class_2487 nbt) {
        DecayProcessor.super.toNbt(nbt);
        nbt.method_10582("block", class_2378.field_11146.method_10221(block).toString());
        nbt.method_10569("entropy", entropy);
        return nbt;
    }

    @Override
    public DecayProcessorType<? extends DecayProcessor> getType() {
        return DecayProcessorType.SIMPLE_PROCESSOR_TYPE;
    }

    @Override
    public String getKey() {
        return KEY;
    }

    @Override
    public int process(class_1937 world, class_2338 pos, class_2680 origin, class_2680 target) {
    	class_2680 newState = block.method_9564();
    	Set<class_2769<?>> commonProperties = target.method_28501().stream().filter(newState.method_28501()::contains).collect(Collectors.toSet());
    	for(class_2769<?> property : commonProperties) {
    		newState = transferProperty(target, newState, property);
		}
        world.method_8501(pos, newState);
        return entropy;
    }

	private static <T extends Comparable<T>> class_2680 transferProperty(class_2680 from, class_2680 to, class_2769<T> property) {
		return to.method_11657(property, from.method_11654(property));
	}

    public static SimpleDecayProcesor.Builder builder() {
        return new SimpleDecayProcesor.Builder();
    }

    public static class Builder {
        private class_2248 block = class_2246.field_10124;
        private int entropy;

        public SimpleDecayProcesor.Builder block(class_2248 block) {
            this.block = block;
            return this;
        }

        public SimpleDecayProcesor.Builder entropy(int entropy) {
            this.entropy = entropy;
            return this;
        }

        public SimpleDecayProcesor create() {
            return new SimpleDecayProcesor(block, entropy);
        }
    }
}
