package org.dimdev.dimdoors.world.feature.gateway;

import java.util.Set;
import net.minecraft.class_2338;
import net.minecraft.class_2350;
import net.minecraft.class_2680;
import net.minecraft.class_5281;
import com.google.common.collect.ImmutableSet;
import org.dimdev.dimdoors.block.ModBlocks;
import org.dimdev.dimdoors.world.ModBiomes;
import org.dimdev.dimdoors.world.ModDimensions;

public enum LimboGateway implements Gateway {
    INSTANCE;

    @Override
    public void generate(class_5281 world, class_2338 pos) {
        if (!this.isLocationValid(world, pos)) {
            return;
        }
        class_2680 unravelledFabric = ModBlocks.UNRAVELLED_FABRIC.method_9564();
        // Build the gateway out of Unraveled Fabric. Since nearly all the blocks in Limbo are of
        // that type, there is no point replacing the ground.
        world.method_8652(pos.method_10069(1, 3, 0), unravelledFabric, 2);
        world.method_8652(pos.method_10069(-1, 3, 0), unravelledFabric, 2);

        // Build the columns around the door
        world.method_8652(pos.method_10069(-1, 2, 0), unravelledFabric, 2);
        world.method_8652(pos.method_10069(1, 2, 0), unravelledFabric, 2);
        world.method_8652(pos.method_10069(1, 1, 0), unravelledFabric, 2);
        world.method_8652(pos.method_10069(1, 1, 0), unravelledFabric, 2);

        this.placePortal(world, pos.method_10069(0, 1, 0), class_2350.field_11043);
    }

    @Override
    public boolean isLocationValid(class_5281 world, class_2338 pos) {
        return ModDimensions.isLimboDimension(world.method_8410());
    }

    private void placePortal(class_5281 world, class_2338 pos, class_2350 facing) {
        world.method_8652(pos, ModBlocks.DIMENSIONAL_PORTAL.method_9564(), 2);
    }
}
