package org.dimdev.dimdoors.world.feature.gateway.schematic;

import net.minecraft.class_2246;
import net.minecraft.class_2338;
import net.minecraft.class_5281;

public class TwoPillarsGateway extends SchematicGateway {
	private static final int GATEWAY_RADIUS = 4;

	public TwoPillarsGateway() {
		super("two_pillars");
	}

	@Override
	protected void generateRandomBits(class_5281 world, class_2338 pos) {
		//Replace some of the ground around the gateway with bricks
		for (int xc = -GATEWAY_RADIUS; xc <= GATEWAY_RADIUS; xc++) {
			for (int zc = -GATEWAY_RADIUS; zc <= GATEWAY_RADIUS; zc++) {
				//Check that the block is supported by an opaque block.
				//This prevents us from building over a cliff, on the peak of a mountain,
				//or the surface of the ocean or a frozen lake.
				if (world.method_8320(pos.method_10069(xc, -1, zc)).method_26207().method_15799()) {
					//Randomly choose whether to place bricks or not. The math is designed so that the
					//chances of placing a block decrease as we get farther from the gateway's center.
					int i = Math.abs(xc) + Math.abs(zc);
					if (i < world.method_8409().method_43048(2) + 3) {
						//Place Stone Bricks
						world.method_8652(pos.method_10069(xc, 0, zc), class_2246.field_10056.method_9564(), 2);
					} else if (i < world.method_8409().method_43048(3) + 3) {
						//Place Cracked Stone Bricks
						world.method_8652(pos.method_10069(xc, 0, zc), class_2246.field_10416.method_9564(), 2);
					}
				}
			}
		}
	}

	@Override
	public boolean test(class_5281 structureWorldAccess, class_2338 blockPos) {
		return !structureWorldAccess.method_8320(blockPos).method_27852(class_2246.field_10382);
	}
}
