package org.dimdev.dimdoors.world.level.component;

import dev.onyxstudios.cca.api.v3.component.Component;
import org.dimdev.dimdoors.DimensionalDoorsComponents;

import net.fabricmc.fabric.api.util.NbtType;
import net.minecraft.class_2487;
import net.minecraft.class_2791;

public class ChunkLazilyGeneratedComponent implements Component {
	private boolean hasBeenLazyGenned = false;

	public boolean hasBeenLazyGenned() {
		return hasBeenLazyGenned;
	}

	public void setGenned() {
		if (hasBeenLazyGenned) throw new UnsupportedOperationException("This chunk seems to have already been lazily generated!");
		hasBeenLazyGenned = true;
	}

	public static ChunkLazilyGeneratedComponent get(class_2791 chunk) {
		return DimensionalDoorsComponents.CHUNK_LAZILY_GENERATED_COMPONENT_KEY.get(chunk);
	}

	@Override
	public void readFromNbt(class_2487 nbt) {
		if (nbt.method_10573("has_been_lazy_genned", NbtType.INT)) {
			hasBeenLazyGenned = nbt.method_10550("has_been_lazy_genned") == 1;
		}
	}

	@Override
	public void writeToNbt(class_2487 nbt) {
		if (hasBeenLazyGenned) {
			nbt.method_10569("has_been_lazy_genned", 1);
		}
	}
}
