package org.dimdev.dimdoors.world.pocket.type.addon;

import net.fabricmc.fabric.api.util.NbtType;
import net.minecraft.class_2487;
import net.minecraft.class_2499;
import net.minecraft.class_2520;
import net.minecraft.class_2960;
import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

public abstract class AddonContainer<T extends ContainedAddon> implements PocketAddon {
	protected class_2960 id;
	protected List<T> addons = new ArrayList<>();

	public AddonContainer() {
	}

	public void setId(class_2960 id) {
		this.id = id;
	}

	public void addAll(Collection<T> addons) {
		this.addons.addAll(addons);
	}

	public void add(T addon) {
		this.addons.add(addon);
	}

	@Override
	public PocketAddon fromNbt(class_2487 nbt) {
		this.id = class_2960.method_12829(nbt.method_10558("id"));

		if (nbt.method_10573("addons", NbtType.LIST)) {
			for (class_2520 addonTag : nbt.method_10554("addons", NbtType.COMPOUND)) {
				addons.add((T) PocketAddon.deserialize((class_2487) addonTag));
			}
		}

		return this;
	}

	@Override
	public class_2487 toNbt(class_2487 nbt) {
		PocketAddon.super.toNbt(nbt);

		class_2499 addonsTag = new class_2499();
		for(T addon : addons) {
			addonsTag.add(addon.toNbt(new class_2487()));
		}
		nbt.method_10566("addons", addonsTag);

		return null;
	}

	@Override
	public class_2960 getId() {
		return id;
	}
}

