package org.dimdev.dimdoors.world.pocket.type.addon;


import org.dimdev.dimdoors.world.pocket.type.Pocket;

import java.util.Map;
import net.minecraft.class_2960;

public interface ContainedAddon extends PocketAddon {
	class_2960 getContainerId();

	@Override
	default void addAddon(Map<class_2960, PocketAddon> addons) {
		throw new UnsupportedOperationException("ContainedEventListenerAddons cannot be attach to a Pocket directly");
	}

	interface ContainedBuilderAddon<T extends ContainedAddon> extends PocketAddon.PocketBuilderAddon<T> {
		class_2960 getContainerId();

		AddonContainer<T> supplyContainer();

		@Override
		default void apply(Pocket pocket) {
			AddonContainer<T> container;
			if (pocket.hasAddon(getContainerId())) {
				container = pocket.getAddon(getContainerId());
			} else {
				container = supplyContainer();
				pocket.addAddon(container);
			}
			container.add(buildAddon());
		}

		T buildAddon();
	}
}
