package org.dimdev.dimdoors.world.pocket.type.addon;

import com.mojang.serialization.Lifecycle;
import net.fabricmc.fabric.api.event.registry.FabricRegistryBuilder;
import net.minecraft.class_2370;
import net.minecraft.class_2378;
import net.minecraft.class_2487;
import net.minecraft.class_2960;
import net.minecraft.class_5321;
import org.dimdev.dimdoors.DimensionalDoorsInitializer;
import org.dimdev.dimdoors.world.pocket.type.Pocket;
import org.dimdev.dimdoors.world.pocket.type.addon.blockbreak.BlockBreakContainer;

import java.util.Map;
import java.util.function.Supplier;

public interface PocketAddon {
	class_2378<PocketAddonType<? extends PocketAddon>> REGISTRY = FabricRegistryBuilder.from(new class_2370<PocketAddonType<? extends PocketAddon>>(class_5321.method_29180(new class_2960("dimdoors", "pocket_applicable_addon_type")), Lifecycle.stable(), null)).buildAndRegister();

	static PocketAddon deserialize(class_2487 nbt) {
		class_2960 id = class_2960.method_12829(nbt.method_10558("type")); // TODO: NONE PocketAddon type;
		return REGISTRY.method_10223(id).fromNbt(nbt);
	}

	static PocketBuilderAddon<?> deserializeBuilder(class_2487 nbt) {
		class_2960 id = class_2960.method_12829(nbt.method_10558("type")); // TODO: NONE PocketAddon type;
		return REGISTRY.method_10223(id).builderAddonInstance().fromNbt(nbt);
	}

	static class_2487 serialize(PocketAddon addon) {
		return addon.toNbt(new class_2487());
	}


	default boolean applicable(Pocket pocket) {
		return true;
	}

	PocketAddon fromNbt(class_2487 nbt);

	default class_2487 toNbt(class_2487 nbt) {
		return this.getType().toNbt(nbt);
	}

	PocketAddonType<? extends PocketAddon> getType();

	class_2960 getId();

	default void addAddon(Map<class_2960, PocketAddon> addons) {
		addons.put(getId(), this);
	}

	interface PocketBuilderExtension<T extends Pocket.PocketBuilder<T, ?>> {
		public <C extends PocketBuilderAddon<?>> C getAddon(class_2960 id);

		T getSelf();
	}

	interface PocketBuilderAddon<T extends PocketAddon> {
		default boolean applicable(Pocket.PocketBuilder<?, ?> builder) {
			return true;
		}

		// makes it possible for addons themselves to control how they are added
		default void addAddon(Map<class_2960, PocketBuilderAddon<?>> addons) {
			addons.put(getId(), this);
		}

		void apply(Pocket pocket);

		class_2960 getId();

		PocketBuilderAddon<T> fromNbt(class_2487 nbt);

		default class_2487 toNbt(class_2487 nbt) {
			return this.getType().toNbt(nbt);
		}

		PocketAddonType<T> getType();
	}

	interface PocketAddonType<T extends PocketAddon> {
		PocketAddonType<DyeableAddon> DYEABLE_ADDON = register(DyeableAddon.ID, DyeableAddon::new, DyeableAddon.DyeableBuilderAddon::new);
		PocketAddonType<PreventBlockModificationAddon> PREVENT_BLOCK_MODIFICATION_ADDON = register(PreventBlockModificationAddon.ID, PreventBlockModificationAddon::new, PreventBlockModificationAddon.PreventBlockModificationBuilderAddon::new);
		PocketAddonType<BlockBreakContainer> BLOCK_BREAK_CONTAINER = register(BlockBreakContainer.ID, BlockBreakContainer::new, null);
		PocketAddonType<SkyAddon> SKY_ADDON = register(SkyAddon.ID, SkyAddon::new, SkyAddon.SkyBuilderAddon::new);

		T fromNbt(class_2487 nbt);

		class_2487 toNbt(class_2487 nbt);

		T instance();

		PocketBuilderAddon<T> builderAddonInstance();

		class_2960 identifier();

		static void register() {
			DimensionalDoorsInitializer.apiSubscribers.forEach(d -> d.registerPocketAddonTypes(REGISTRY));
		}

		static <U extends PocketAddon> PocketAddonType<U> register(class_2960 id, Supplier<U> factory, Supplier<PocketBuilderAddon<U>> addonSupplier) {
			return class_2378.method_10230(REGISTRY, id, new PocketAddonType<U>() {
				@Override
				public U fromNbt(class_2487 nbt) {
					return (U) factory.get().fromNbt(nbt);
				}

				@Override
				public class_2487 toNbt(class_2487 nbt) {
					nbt.method_10582("type", id.toString());
					return nbt;
				}

				@Override
				public U instance() {
					return factory.get();
				}

				@Override
				public PocketBuilderAddon<U> builderAddonInstance() {
					if (addonSupplier == null) return null;
					return addonSupplier.get();
				}

				@Override
				public class_2960 identifier() {
					return id;
				}
			});
		}
	}
}
