package org.dimdev.dimdoors.world.pocket.type.addon;

import java.io.IOException;
import net.minecraft.class_1937;
import net.minecraft.class_2378;
import net.minecraft.class_2487;
import net.minecraft.class_2540;
import net.minecraft.class_2960;
import net.minecraft.class_5321;
import org.dimdev.dimdoors.world.pocket.type.Pocket;

public class SkyAddon implements AutoSyncedAddon {
	public static class_2960 ID = new class_2960("dimdoors", "sky");

	private class_5321<class_1937> world;

	public boolean setWorld(class_5321<class_1937> world) {
		this.world = world;
		return true;
	}

	@Override
	public PocketAddon fromNbt(class_2487 nbt) {
		this.world = class_5321.method_29179(class_2378.field_25298, class_2960.method_12829(nbt.method_10558("world")));

		return this;
	}

	@Override
	public class_2487 toNbt(class_2487 nbt) {
		AutoSyncedAddon.super.toNbt(nbt);

		nbt.method_10582("world", this.world.method_29177().toString());

		return nbt;
	}

	@Override
	public PocketAddonType<? extends PocketAddon> getType() {
		return PocketAddonType.SKY_ADDON;
	}

	@Override
	public class_2960 getId() {
		return ID;
	}

	public class_5321<class_1937> getWorld() {
		return world;
	}

	@Override
	public AutoSyncedAddon read(class_2540 buf) throws IOException {
		this.world = class_5321.method_29179(class_2378.field_25298, buf.method_10810());
		return this;
	}

	@Override
	public class_2540 write(class_2540 buf) throws IOException {
		buf.method_10812(world.method_29177());
		return buf;
	}

	public interface SkyPocketBuilder<T extends Pocket.PocketBuilder<T, ?>> extends PocketBuilderExtension<T> {
		default T world(class_5321<class_1937> world) {

			this.<SkyBuilderAddon>getAddon(ID).world = world;

			return getSelf();
		}
	}

	public static class SkyBuilderAddon implements PocketBuilderAddon<SkyAddon> {

		private class_5321<class_1937> world = class_1937.field_25179;

		@Override
		public void apply(Pocket pocket) {
			SkyAddon addon = new SkyAddon();
			addon.world = world;
			pocket.addAddon(addon);
		}

		@Override
		public class_2960 getId() {
			return ID;
		}

		@Override
		public PocketBuilderAddon<SkyAddon> fromNbt(class_2487 nbt) {
			this.world = class_5321.method_29179(class_2378.field_25298, class_2960.method_12829(nbt.method_10558("world")));

			return this;
		}

		@Override
		public class_2487 toNbt(class_2487 nbt) {
			PocketBuilderAddon.super.toNbt(nbt);

			nbt.method_10582("world", world.method_29177().toString());

			return nbt;
		}

		@Override
		public PocketAddonType<SkyAddon> getType() {
			return PocketAddonType.SKY_ADDON;
		}
	}

	public interface SkyPocket extends AddonProvider {
		default boolean sky(class_5321<class_1937> world) {
			ensureIsPocket();
			if (!this.hasAddon(ID)) {
				SkyAddon addon = new SkyAddon();
				this.addAddon(addon);
				return addon.setWorld(world);
			}
			return this.<SkyAddon>getAddon(ID).setWorld(world);
		}
	}
}
